module Hexlet where

import Graphics.Rendering.OpenGL
import Circles
import SteinerChain
import Data.List
import FourthCircle1
import SteinerRadSolver
import SphereCoord
import Spheres
import PointsForRendering
import RadLength
import SteinerRadSolver
import TouchingSphere
import SteinerCenter 
 

locally = preservingMatrix

hexlet x y z rad x2 y2 r3 r = do
 clearColor $= Color4 1 1 1 1
 clear [ColorBuffer]
   
 locally $ do
  currentColor $= Color4 0 0 0 1  
  sphereAt x y z rad
  
 locally $ do
  currentColor $= Color4 0.4 0 0 1 
  touchSpheres x y z rad x2 y2 z
  
 locally $ do 
  currentColor $= Color4 0.4 0 0 1 
  treeSpheres3 x y rad x2 y2 r3 z
  
 locally $ do
  currentColor $=Color4 1 0 0 1
  sphereAt  (fst smallCenter) (snd smallCenter) 0 r2 -- This is the sphere that is defined by the two small inscribed spheres (It is the bright red one)
   
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  fourSpheres3 x1 z r1 x1 d r2 (z) ((chain x1 z r1 x1 d r2 r 3)!!1)
   
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  fourSpheres4 x1 z r1 x1 d r2 (z) ((chain x1 z r1 x1 d r2 r 3)!!0)
  
 locally $ do  
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  fourSpheres2 x1 z r1 x1 d r2 (z) ((chain x1 z r1 x1 d r2 r 3)!!2)
    
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  fourSpheres2 x1 z r1 x1 d r2 (z) ((chain x1 z r1 x1 d r2 r 3)!!3)
    
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  fourSpheres x1 z r1 x1 d r2 (z) ((chain x1 z r1 x1 d r2 r 3)!!3)
     
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  translate $Vector3 (x1/2) (2*x1) (-x1::GLfloat)
  rotate (-alpha) $Vector3 0 0 (1::GLfloat)
  treeSpheres x1 z r1 x1 d r2 (z) r
   
  where alpha =(beta)
        dist = fst(getRotCoord x y (fst largeCenter) (snd largeCenter))
        beta = snd(getRotCoord x y (fst largeCenter) (snd largeCenter))
        smallCenter = getCoords x2 y2 (radComp x y rad x2 y2) (fst(coordComp2 x y rad x2 y2 (radComp x y rad x2 y2) r3)) (snd(coordComp2 x y rad x2 y2 (radComp x y rad x2 y2) r3)) r3 
        largeCenter = steinerCenter x2 y2 (radComp x y rad x2 y2) (fst(coordComp2 x y rad x2 y2 (radComp x y rad x2 y2) r3)) (snd(coordComp2 x y rad x2 y2 (radComp x y rad x2 y2) r3)) r3 x y rad
        d = fst(getRotCoord (fst largeCenter) (snd largeCenter)  (fst smallCenter) (snd smallCenter))
       -- beta = snd(getRotCoord (fst largeCenter) (snd largeCenter)  ((fst smallCenter)) ((snd smallCenter)))
        r1 = radius x2 y2 (radComp x y rad x2 y2) (fst(coordComp x y rad x2 y2 (radComp x y rad x2 y2) r3)) (snd(coordComp x y rad x2 y2 (radComp x y rad x2 y2) r3)) r3 x y rad
        x1 = fst largeCenter
        y1 = snd largeCenter
        r2 = computeR r1 d 6
                
mainc = do
  renderInWindow  (hexlet 0 0 0 0.4 0.3 0.11 0.17 0.15)