module PointsForRendering where

import Graphics.UI.GLUT
import Graphics.Rendering.OpenGL

renderInWindow displayFunction = do
  (progName,_)<-getArgsAndInitialize
  createWindow progName
  windowSize $= Size 800 800
  displayCallback $= displayFunction
  mainLoop
  
displayPoints points primitiveShape = do  
  renderAs primitiveShape points
  flush
  
renderAs figure ps = renderPrimitive figure $ makeVertex ps

makeVertex = mapM_ (\(x,y,z)->vertex $ Vertex3 x y z)

mainFor primitiveShape
 = renderInWindow (displayMyPoints primitiveShape)
   
displayMyPoints primitiveShape = do   
  clear [ColorBuffer]
  clearColor $= Color4 0.139 0 0 0.139
  currentColor $= Color4  1 1 0 1
  displayPoints myPoints primitiveShape
  
myPoints = [(0.2,-0.4,0::GLfloat),
            (0.46,-0.26,0),
            (0.6,0,0),
            (0.6,0.2,0),
            (0.46,0.46,0),
            (0.2,0.6,0),
            (0.0,0.6,0),
            (-0.26,0.46,0),
            (-0.4,0.2,0),
            (-0.4,0,0),
            (-0.26,-0.26,0),
            (0.0,-0.4,0)]
           