module SphereCoord where

import Circles
import SteinerChain
import FourthCircle1
import Sphere
import Graphics.Rendering.OpenGL

treeSpheresCoord x z radius a c rad y r = do    
  (q,z)
  where
    p =fst (pointsOfCrossing x' y' radius' a' b' rad')
    q =snd (pointsOfCrossing x' y' radius' a' b' rad')
    x'=x
    y'=z
    a'=a
    b'=c
    radius' = radius-r  
    rad'=rad+r
    
treeSpheresCoord2 x z radius a c rad y r = do    
  (q,z)
  where
    p =fst (pointsOfCrossing2 x' y' radius' a' b' rad')
    q =snd (pointsOfCrossing2 x' y' radius' a' b' rad')
    x'=x
    y'=z
    a'=a
    b'=c
    radius' = radius-r  
    rad'=rad+r

treeSpheres x z radius a c rad y r = do    
  translate$Vector3 q z (p::GLfloat)  
  renderSphere r
  where
    p =fst (pointsOfCrossing x' y' radius' a' b' rad')
    q =snd (pointsOfCrossing x' y' radius' a' b' rad')
    x'=x
    y'=z
    a'=a
    b'=c
    radius' = radius-r  
    rad'=rad+r --draws 3rd circle wich touches 2 circles one of which is incribed in the other

treeSpheres2 x z radius a c rad y r = do    
  translate$Vector3 q z (p::GLfloat)  
  renderSphere r
  where
    p =fst (pointsOfCrossing2 x' y' radius' a' b' rad')
    q =snd (pointsOfCrossing2 x' y' radius' a' b' rad')
    x'=x
    y'=z
    a'=a
    b'=c
    radius' = radius-r  
    rad'=rad+r

fourSpheresCoord a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheresCoord a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr )

fourSpheresCoord2 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheresCoord2 a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr )
    
fourSpheresCoord3 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheresCoord2 a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr )    

fourSpheresCoord4 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheresCoord a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr ) 




fourSpheres a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheres a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp a1 b1 r1 a2 b2 r2 rpr)) rpr )

fourSpheres2 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheres2 a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr )
    
fourSpheres3 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheres2 a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp a1 b1 r1 a2 b2 r2 rpr)) rpr )    

fourSpheres4 a1 b1 r1 a2 b2 r2 y rpr = do
  treeSpheres a1 b1 r1 a2 b2 r2 y r
  where
    r = (fourthcirclerad a1 b1 r1 a2 b2 r2 (fst(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) (snd(coordComp2 a1 b1 r1 a2 b2 r2 rpr)) rpr )    

    
getRotCoord x1 y1 x2 y2 = do    
  (sqrt((x1-x2)^2+(y1-y2)^2),alpha)
  where alpha = (180*atan((x1-x2)/(y1-y2)))/pi
        
        


  
  
  
 