module Spheres where

import PointsForRendering
import Sphere
import Graphics.Rendering.OpenGL
import Data.List
import RadLength
import Circles
import SphereCoord

sphereAt x y z radius = do
  translate$Vector3 x y (z::GLfloat)
  renderSphere radius
          
circleOfSpheres x y z r a b c = do        
  translate$Vector3 x y (z::GLfloat)
  renderSphere (sqrt(((x-a)*(x-a))+((y-b)*(y-b))+((z-c)*(z-c))))

touchSpheres x y z radius a b c = do
  translate$Vector3 a b (c::GLfloat)
  renderSphere (radius-(sqrt(((x-a)*(x-a))+((y-b)*(y-b))+((z-c)*(z-c)))))
  
treeSpheres3 x y radius a b r z = do  
  translate$Vector3 p q (z::GLfloat)
  renderSphere r
  where  
    p =fst (pointsOfCrossing2 x' y' radius' a' b' rad')
    q =snd (pointsOfCrossing2 x' y' radius' a' b' rad')
    x'=x
    y'=y
    a'=a
    b'=b
    radius' = radius-r
    rad' = (radComp x y radius a b)+r 

 
  
    
  