module SteinerCenter where



steinerCenter x1 y1 r1 x2 y2 r2 a b r = do  
  (x,y)
  where 
   y= (-r1^2 + r2^2 - 2*(-x)*x1 + x1^2 + 2*(-x)*x2 - x2^2 + y1^2 - y2^2)/
          (2*(y1 - y2))
  
   x = (-4*r1^2*x1^3 + 4*r2^2*x1^3 + 4*x1^5 + 12*r1^2*x1^2*x2 - 
          12*r2^2*x1^2*x2 - 12*x1^4*x2 - 12*r1^2*x1*x2^2 + 
    12*r2^2*x1*x2^2 + 
          8*x1^3*x2^2 + 4*r1^2*x2^3 - 4*r2^2*x2^3 + 8*x1^2*x2^3 - 
    12*x1*x2^4 + 
          4*x2^5 - 8*b*x1^3*y1 + 24*b*x1^2*x2*y1 - 24*b*x1*x2^2*y1 + 
          8*b*x2^3*y1 - 4*r1^2*x1*y1^2 + 4*r2^2*x1*y1^2 + 
    8*a*x1^2*y1^2 + 
          8*x1^3*y1^2 + 4*r1^2*x2*y1^2 - 4*r2^2*x2*y1^2 - 
    16*a*x1*x2*y1^2 - 
          16*x1^2*x2*y1^2 + 8*a*x2^2*y1^2 + 8*x1*x2^2*y1^2 - 
    8*b*x1*y1^3 + 
          8*b*x2*y1^3 + 8*a*y1^4 + 4*x1*y1^4 - 4*x2*y1^4 + 
    8*b*x1^3*y2 - 
          24*b*x1^2*x2*y2 + 24*b*x1*x2^2*y2 - 8*b*x2^3*y2 + 
    8*r1^2*x1*y1*y2 - 
          8*r2^2*x1*y1*y2 - 16*a*x1^2*y1*y2 - 8*x1^3*y1*y2 - 
    8*r1^2*x2*y1*y2 + 
          8*r2^2*x2*y1*y2 + 32*a*x1*x2*y1*y2 + 8*x1^2*x2*y1*y2 - 
          16*a*x2^2*y1*y2 + 8*x1*x2^2*y1*y2 - 8*x2^3*y1*y2 + 
    24*b*x1*y1^2*y2 - 
          24*b*x2*y1^2*y2 - 32*a*y1^3*y2 - 8*x1*y1^3*y2 + 
    8*x2*y1^3*y2 - 
          4*r1^2*x1*y2^2 + 4*r2^2*x1*y2^2 + 8*a*x1^2*y2^2 + 
    4*r1^2*x2*y2^2 - 
          4*r2^2*x2*y2^2 - 16*a*x1*x2*y2^2 + 8*x1^2*x2*y2^2 + 
    8*a*x2^2*y2^2 - 
          16*x1*x2^2*y2^2 + 8*x2^3*y2^2 - 24*b*x1*y1*y2^2 + 
    24*b*x2*y1*y2^2 + 
          48*a*y1^2*y2^2 + 8*b*x1*y2^3 - 8*b*x2*y2^3 - 
    32*a*y1*y2^3 + 
          8*x1*y1*y2^3 - 8*x2*y1*y2^3 + 8*a*y2^4 - 4*x1*y2^4 + 
    4*x2*y2^4 - 
          sqrt((4*r1^2*x1^3 - 4*r2^2*x1^3 - 4*x1^5 - 12*r1^2*x1^2*x2 + 
                   12*r2^2*x1^2*x2 + 12*x1^4*x2 + 12*r1^2*x1*x2^2 - 
                   12*r2^2*x1*x2^2 - 8*x1^3*x2^2 - 4*r1^2*x2^3 + 
         4*r2^2*x2^3 - 
                   8*x1^2*x2^3 + 12*x1*x2^4 - 4*x2^5 + 8*b*x1^3*y1 - 
                   24*b*x1^2*x2*y1 + 24*b*x1*x2^2*y1 - 8*b*x2^3*y1 + 
                   4*r1^2*x1*y1^2 - 4*r2^2*x1*y1^2 - 8*a*x1^2*y1^2 - 
         8*x1^3*y1^2 - 
                   4*r1^2*x2*y1^2 + 4*r2^2*x2*y1^2 + 16*a*x1*x2*y1^2 + 
                   16*x1^2*x2*y1^2 - 8*a*x2^2*y1^2 - 8*x1*x2^2*y1^2 + 
         8*b*x1*y1^3 - 
                   8*b*x2*y1^3 - 8*a*y1^4 - 4*x1*y1^4 + 4*x2*y1^4 - 
         8*b*x1^3*y2 + 
                   24*b*x1^2*x2*y2 - 24*b*x1*x2^2*y2 + 8*b*x2^3*y2 - 
                   8*r1^2*x1*y1*y2 + 8*r2^2*x1*y1*y2 + 
         16*a*x1^2*y1*y2 + 
                   8*x1^3*y1*y2 + 8*r1^2*x2*y1*y2 - 
         8*r2^2*x2*y1*y2 - 
                   32*a*x1*x2*y1*y2 - 8*x1^2*x2*y1*y2 + 
         16*a*x2^2*y1*y2 - 
                   8*x1*x2^2*y1*y2 + 8*x2^3*y1*y2 - 
         24*b*x1*y1^2*y2 + 
                   24*b*x2*y1^2*y2 + 32*a*y1^3*y2 + 8*x1*y1^3*y2 - 
         8*x2*y1^3*y2 + 
                   4*r1^2*x1*y2^2 - 4*r2^2*x1*y2^2 - 8*a*x1^2*y2^2 - 
                   4*r1^2*x2*y2^2 + 4*r2^2*x2*y2^2 + 16*a*x1*x2*y2^2 - 
                   8*x1^2*x2*y2^2 - 8*a*x2^2*y2^2 + 16*x1*x2^2*y2^2 - 
         8*x2^3*y2^2 + 
                   24*b*x1*y1*y2^2 - 24*b*x2*y1*y2^2 - 
         48*a*y1^2*y2^2 - 
                   8*b*x1*y2^3 + 8*b*x2*y2^3 + 32*a*y1*y2^3 - 
         8*x1*y1*y2^3 + 
                   8*x2*y1*y2^3 - 8*a*y2^4 + 4*x1*y2^4 - 
         4*x2*y2^4)^2 - 
              
      4*(4*x1^4 - 16*x1^3*x2 + 24*x1^2*x2^2 - 16*x1*x2^3 + 4*x2^4 + 
                   8*x1^2*y1^2 - 16*x1*x2*y1^2 + 8*x2^2*y1^2 + 
         4*y1^4 - 
                   16*x1^2*y1*y2 + 32*x1*x2*y1*y2 - 16*x2^2*y1*y2 - 
         16*y1^3*y2 + 
                   8*x1^2*y2^2 - 16*x1*x2*y2^2 + 8*x2^2*y2^2 + 
         24*y1^2*y2^2 - 
                   16*y1*y2^3 + 4*y2^4)*(r1^4*x1^2 - 
         2*r1^2*r2^2*x1^2 + r2^4*x1^2 - 
                   2*r1^2*x1^4 + 2*r2^2*x1^4 + x1^6 - 2*r1^4*x1*x2 + 
                   4*r1^2*r2^2*x1*x2 - 2*r2^4*x1*x2 + 4*r1^2*x1^3*x2 - 
                   4*r2^2*x1^3*x2 - 2*x1^5*x2 + r1^4*x2^2 - 
         2*r1^2*r2^2*x2^2 + 
                   r2^4*x2^2 - x1^4*x2^2 - 4*r1^2*x1*x2^3 + 
         4*r2^2*x1*x2^3 + 
                   4*x1^3*x2^3 + 2*r1^2*x2^4 - 2*r2^2*x2^4 - 
         x1^2*x2^4 - 2*x1*x2^5 + 
                   x2^6 + 4*b*r1^2*x1^2*y1 - 4*b*r2^2*x1^2*y1 - 
         4*b*x1^4*y1 - 
                   8*b*r1^2*x1*x2*y1 + 8*b*r2^2*x1*x2*y1 + 
         8*b*x1^3*x2*y1 + 
                   4*b*r1^2*x2^2*y1 - 4*b*r2^2*x2^2*y1 - 
         8*b*x1*x2^3*y1 + 
                   4*b*x2^4*y1 + r1^4*y1^2 - 2*r1^2*r2^2*y1^2 + 
         r2^4*y1^2 + 
                   4*a^2*x1^2*y1^2 + 4*b^2*x1^2*y1^2 - 
         4*r1^2*x1^2*y1^2 + 
                   4*r2^2*x1^2*y1^2 + 3*x1^4*y1^2 - 8*a^2*x1*x2*y1^2 - 
                   8*b^2*x1*x2*y1^2 + 4*r1^2*x1*x2*y1^2 - 
         4*r2^2*x1*x2*y1^2 - 
                   4*x1^3*x2*y1^2 + 4*a^2*x2^2*y1^2 + 
         4*b^2*x2^2*y1^2 - 
                   2*x1^2*x2^2*y1^2 + 4*x1*x2^3*y1^2 - x2^4*y1^2 + 
         4*b*r1^2*y1^3 - 
                   4*b*r2^2*y1^3 - 8*b*x1^2*y1^3 + 8*b*x1*x2*y1^3 + 
         4*a^2*y1^4 + 
                   4*b^2*y1^4 - 2*r1^2*y1^4 + 2*r2^2*y1^4 + 
         3*x1^2*y1^4 - 
                   2*x1*x2*y1^4 - x2^2*y1^4 - 4*b*y1^5 + y1^6 - 
         4*b*r1^2*x1^2*y2 + 
                   4*b*r2^2*x1^2*y2 + 4*b*x1^4*y2 + 
         8*b*r1^2*x1*x2*y2 - 
                   8*b*r2^2*x1*x2*y2 - 8*b*x1^3*x2*y2 - 
         4*b*r1^2*x2^2*y2 + 
                   4*b*r2^2*x2^2*y2 + 8*b*x1*x2^3*y2 - 4*b*x2^4*y2 - 
         2*r1^4*y1*y2 + 
                   4*r1^2*r2^2*y1*y2 - 2*r2^4*y1*y2 - 
         8*a^2*x1^2*y1*y2 - 
                   8*b^2*x1^2*y1*y2 + 4*r1^2*x1^2*y1*y2 - 
         4*r2^2*x1^2*y1*y2 - 
                   2*x1^4*y1*y2 + 16*a^2*x1*x2*y1*y2 + 
         16*b^2*x1*x2*y1*y2 - 
                   8*a^2*x2^2*y1*y2 - 8*b^2*x2^2*y1*y2 - 
         4*r1^2*x2^2*y1*y2 + 
                   4*r2^2*x2^2*y1*y2 + 4*x1^2*x2^2*y1*y2 - 
         2*x2^4*y1*y2 - 
                   12*b*r1^2*y1^2*y2 + 12*b*r2^2*y1^2*y2 + 
         16*b*x1^2*y1^2*y2 - 
                   8*b*x1*x2*y1^2*y2 - 8*b*x2^2*y1^2*y2 - 
         16*a^2*y1^3*y2 - 
                   16*b^2*y1^3*y2 + 4*r1^2*y1^3*y2 - 
         4*r2^2*y1^3*y2 - 
                   4*x1^2*y1^3*y2 + 4*x2^2*y1^3*y2 + 12*b*y1^4*y2 - 
         2*y1^5*y2 + 
                   r1^4*y2^2 - 2*r1^2*r2^2*y2^2 + r2^4*y2^2 + 
         4*a^2*x1^2*y2^2 + 
                   4*b^2*x1^2*y2^2 - x1^4*y2^2 - 8*a^2*x1*x2*y2^2 - 
                   8*b^2*x1*x2*y2^2 - 4*r1^2*x1*x2*y2^2 + 
         4*r2^2*x1*x2*y2^2 + 
                   4*x1^3*x2*y2^2 + 4*a^2*x2^2*y2^2 + 
         4*b^2*x2^2*y2^2 + 
                   4*r1^2*x2^2*y2^2 - 4*r2^2*x2^2*y2^2 - 
         2*x1^2*x2^2*y2^2 - 
                   4*x1*x2^3*y2^2 + 3*x2^4*y2^2 + 
         12*b*r1^2*y1*y2^2 - 
                   12*b*r2^2*y1*y2^2 - 8*b*x1^2*y1*y2^2 - 
         8*b*x1*x2*y1*y2^2 + 
                   16*b*x2^2*y1*y2^2 + 24*a^2*y1^2*y2^2 + 
         24*b^2*y1^2*y2^2 - 
                   2*x1^2*y1^2*y2^2 + 4*x1*x2*y1^2*y2^2 - 
         2*x2^2*y1^2*y2^2 - 
                   8*b*y1^3*y2^2 - y1^4*y2^2 - 4*b*r1^2*y2^3 + 
         4*b*r2^2*y2^3 + 
                   8*b*x1*x2*y2^3 - 8*b*x2^2*y2^3 - 16*a^2*y1*y2^3 - 
                   16*b^2*y1*y2^3 - 4*r1^2*y1*y2^3 + 
         4*r2^2*y1*y2^3 + 
                   4*x1^2*y1*y2^3 - 4*x2^2*y1*y2^3 - 8*b*y1^2*y2^3 + 
         4*y1^3*y2^3 + 
                   4*a^2*y2^4 + 4*b^2*y2^4 + 2*r1^2*y2^4 - 
         2*r2^2*y2^4 - x1^2*y2^4 - 
                   2*x1*x2*y2^4 + 3*x2^2*y2^4 + 12*b*y1*y2^4 - 
         y1^2*y2^4 - 
                   4*b*y2^5 - 2*y1*y2^5 + y2^6 - 
                   
         y1^2*abs(-r1^2 + r2^2 + x1^2 - x2^2 + 2*a*(-x1 + x2) + y1^2 - 
                           y2^2 + 2*b*(-y1 + y2))^2 + 2*y1*y2*
                     
          abs(-r1^2 + r2^2 + x1^2 - x2^2 + 2*a*(-x1 + x2) + y1^2 - 
             y2^2 + 
                           2*b*(-y1 + y2))^2 - 
         y2^2*abs(-r1^2 + r2^2 + x1^2 - x2^2 + 
                           2*a*(-x1 + x2) + y1^2 - y2^2 + 
             2*b*(-y1 + y2))^2)))/
       (2*(4*x1^4 - 16*x1^3*x2 + 24*x1^2*x2^2 - 16*x1*x2^3 + 
      4*x2^4 + 
             8*x1^2*y1^2 - 16*x1*x2*y1^2 + 8*x2^2*y1^2 + 4*y1^4 - 
      16*x1^2*y1*y2 + 
             32*x1*x2*y1*y2 - 16*x2^2*y1*y2 - 16*y1^3*y2 + 
      8*x1^2*y2^2 - 
             16*x1*x2*y2^2 + 8*x2^2*y2^2 + 24*y1^2*y2^2 - 
      16*y1*y2^3 + 4*y2^4))  
       
       
      