module SteinerChain where

import PointsForRendering
import Circle
import Graphics.Rendering.OpenGL
import Data.List
import FourthCircle1
import Circles
import SteinerRadSolver

  
steinerch x1 y1 r1 beta dist r = do --takes coordinates and radius of the bigger circle and the rotation, distance and radius of the smaller one and a given radius (if it exists) for one of the circles in the chain
  
  clearColor $= Color4 1 1 1 1
  clear [ColorBuffer]
  
  loadIdentity
  currentColor $= Color4 0 0 0 1  
  rotate alpha $Vector3 0 0 (1::GLfloat)
  circleAt x1 y1 r1
  
  loadIdentity
  currentColor $=Color4 1 0 0 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  circleAt x1 d r2
  
  loadIdentity 
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  fourCircles3 x1 y1 r1 x1 d r2 ((chain x1 y1 r1 x1 d r2 r 3)!!1)
  
  loadIdentity 
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  fourCircles4 x1 y1 r1 x1 d r2 ((chain x1 y1 r1 x1 d r2 r 3)!!0)
  
  loadIdentity 
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  fourCircles2 x1 y1 r1 x1 d r2 ((chain x1 y1 r1 x1 d r2 r 3)!!2)
   
  loadIdentity 
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  fourCircles2 x1 y1 r1 x1 d r2 ((chain x1 y1 r1 x1 d r2 r 3)!!3)
   
  loadIdentity 
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  fourCircles x1 y1 r1 x1 d r2 ((chain x1 y1 r1 x1 d r2 r 3)!!3)
    
  loadIdentity   
  currentColor $=Color4 0 0.5 0.1 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  treeCircles x1 y1 r1 x1 d r2 r
  
  where alpha = (beta-90)
        d = (dist+y1)
        r2 = computeR r1 dist 6
maina = do  
   renderInWindow
     -- (steinerch 0 0 0.3735 45 0.196 0.15)
    (steinerch 0 0 0.45 135 0.32 0.3)
  
