module TrivialHexlet where

import Graphics.Rendering.OpenGL
import Circles
import SteinerChain
import Data.List
import FourthCircle1
import SteinerRadSolver
import SphereCoord
import Spheres
import PointsForRendering
import RadLength
import SteinerRadSolver

locally = preservingMatrix

hexletTriv x1 y1 z r1 beta dist r = do
 clearColor $= Color4 1 1 1 1
 clear [ColorBuffer]
  
 
 locally $ do
  currentColor $= Color4 0 0 0 1  
  sphereAt x1 y1 z r1
  
 locally $ do
  currentColor $=Color4 1 0 0 1
  rotate alpha $Vector3 0 0 (1::GLfloat)
  sphereAt x1 d z r2 -- This is the sphere that is defined by the two small inscribed spheres
  
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  fourSpheres3 x1 y1 r1 x1 d r2 z ((chain x1 y1 r1 x1 d r2 r 3)!!1)
  
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1 
  fourSpheres4 x1 y1 r1 x1 d r2 z ((chain x1 y1 r1 x1 d r2 r 3)!!0)
  
 locally $ do  
  currentColor $=Color4 0 0.5 0.1 1
  fourSpheres2 x1 y1 r1 x1 d r2 z ((chain x1 y1 r1 x1 d r2 r 3)!!2)
   
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  fourSpheres2 x1 y1 r1 x1 d r2 z ((chain x1 y1 r1 x1 d r2 r 3)!!3)
   
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  fourSpheres x1 y1 r1 x1 d r2 z ((chain x1 y1 r1 x1 d r2 r 3)!!3)
    
 locally $ do 
  currentColor $=Color4 0 0.5 0.1 1
  treeSpheres x1 y1 r1 x1 d r2 z r 
  
  where alpha = beta-90
        d = (dist+y1)
        r2 = computeR r1 dist 6
        