(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14274,        306]
NotebookOptionsPosition[     13962,        290]
NotebookOutlinePosition[     14299,        305]
CellTagsIndexPosition[     14256,        302]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"2", "*", "x", "*", 
        RowBox[{"(", 
         RowBox[{"x2", "-", "x1"}], ")"}]}], "+", 
       RowBox[{"2", "*", "y", "*", 
        RowBox[{"(", 
         RowBox[{"y2", "-", "y1"}], ")"}]}]}], "\[Equal]", 
      RowBox[{
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"x1", "^", "2"}], "+", 
       RowBox[{"y2", "^", "2"}], "-", 
       RowBox[{"y1", "^", "2"}], "+", 
       RowBox[{"r1", "^", "2"}], "-", 
       RowBox[{"r2", "^", "2"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b"}], ")"}], "^", "2"}]}], "\[Equal]", 
      RowBox[{"r", "^", "2"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5614996969657993`*^9, 3.561499796808002*^9}}],

Cell["\<\
{{x -> (4*x1^3 - 4*x2*x1^2 - 4*r1^2*x1 + 4*r2^2*x1 - 
      4*x2^2*x1 + 4*y1^2*x1 - 4*y2^2*x1 - 8*b*y1*x1 + 
      8*b*y2*x1 + 4*x2^3 + 8*a*y1^2 - 4*x2*y1^2 + 
      8*a*y2^2 + 4*x2*y2^2 + 4*r1^2*x2 - 4*r2^2*x2 + 
      8*b*x2*y1 - 8*b*x2*y2 - 16*a*y1*y2 - 
      Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 4*r2^2*x1 + 
          4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 8*b*y1*x1 - 
          8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 4*x2*y1^2 - 
          8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 4*r2^2*x2 - 
          8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^2 - 
        4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
          8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 2*x1^2*r1^2 + 
          2*x2^2*r1^2 - 2*y1^2*r1^2 + 2*y2^2*r1^2 + 
          4*b*y1*r1^2 - 4*b*y2*r1^2 + r2^4 + x1^4 + x2^4 + 
          y1^4 + y2^4 - 4*b*y1^3 - 4*b*y2^3 + 2*r2^2*x1^2 - 
          2*r2^2*x2^2 - 2*x1^2*x2^2 + 4*a^2*y1^2 + 
          4*b^2*y1^2 - 4*r^2*y1^2 + 2*r2^2*y1^2 + 
          2*x1^2*y1^2 - 2*x2^2*y1^2 + 4*a^2*y2^2 + 
          4*b^2*y2^2 - 4*r^2*y2^2 - 2*r2^2*y2^2 - 
          2*x1^2*y2^2 + 2*x2^2*y2^2 - 2*y1^2*y2^2 + 
          4*b*y1*y2^2 - 4*b*r2^2*y1 - 4*b*x1^2*y1 + 
          4*b*x2^2*y1 + 4*b*r2^2*y2 + 4*b*x1^2*y2 - 
          4*b*x2^2*y2 + 4*b*y1^2*y2 - 8*a^2*y1*y2 - 
          8*b^2*y1*y2 + 8*r^2*y1*y2)])/
     (2*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
       8*y1*y2)), y -> (1/(2*y1 - 2*y2))*
     (x1^2 - r1^2 + r2^2 - x2^2 + y1^2 - y2^2 + 
      (x1*Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
            8*r^2*y1*y2)])/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
        4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (x2*Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
            8*r^2*y1*y2)])/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
        4*y1^2 + 4*y2^2 - 8*y1*y2) + (4*r1^2*x1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (4*r2^2*x1^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (4*x1^4)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*r1^2*x1*x2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*r2^2*x1*x2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*x1^3*x2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) + (4*r1^2*x2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (4*r2^2*x2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (8*x1*x2^3)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) + (4*x2^4)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*b*x1^2*y1)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (16*b*x1*x2*y1)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*b*x2^2*y1)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (8*a*x1*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (4*x1^2*y1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*a*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*x1*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (4*x2^2*y1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (8*b*x1^2*y2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (16*b*x1*x2*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*b*x2^2*y2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (16*a*x1*y1*y2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (16*a*x2*y1*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*a*x1*y2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (4*x1^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*a*x2*y2^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*x1*x2*y2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (4*x2^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2))}, 
  {x -> (4*x1^3 - 4*x2*x1^2 - 4*r1^2*x1 + 4*r2^2*x1 - 
      4*x2^2*x1 + 4*y1^2*x1 - 4*y2^2*x1 - 8*b*y1*x1 + 
      8*b*y2*x1 + 4*x2^3 + 8*a*y1^2 - 4*x2*y1^2 + 
      8*a*y2^2 + 4*x2*y2^2 + 4*r1^2*x2 - 4*r2^2*x2 + 
      8*b*x2*y1 - 8*b*x2*y2 - 16*a*y1*y2 + 
      Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 4*r2^2*x1 + 
          4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 8*b*y1*x1 - 
          8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 4*x2*y1^2 - 
          8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 4*r2^2*x2 - 
          8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^2 - 
        4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
          8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 2*x1^2*r1^2 + 
          2*x2^2*r1^2 - 2*y1^2*r1^2 + 2*y2^2*r1^2 + 
          4*b*y1*r1^2 - 4*b*y2*r1^2 + r2^4 + x1^4 + x2^4 + 
          y1^4 + y2^4 - 4*b*y1^3 - 4*b*y2^3 + 2*r2^2*x1^2 - 
          2*r2^2*x2^2 - 2*x1^2*x2^2 + 4*a^2*y1^2 + 
          4*b^2*y1^2 - 4*r^2*y1^2 + 2*r2^2*y1^2 + 
          2*x1^2*y1^2 - 2*x2^2*y1^2 + 4*a^2*y2^2 + 
          4*b^2*y2^2 - 4*r^2*y2^2 - 2*r2^2*y2^2 - 
          2*x1^2*y2^2 + 2*x2^2*y2^2 - 2*y1^2*y2^2 + 
          4*b*y1*y2^2 - 4*b*r2^2*y1 - 4*b*x1^2*y1 + 
          4*b*x2^2*y1 + 4*b*r2^2*y2 + 4*b*x1^2*y2 - 
          4*b*x2^2*y2 + 4*b*y1^2*y2 - 8*a^2*y1*y2 - 
          8*b^2*y1*y2 + 8*r^2*y1*y2)])/
     (2*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
       8*y1*y2)), y -> (1/(2*y1 - 2*y2))*
     (x1^2 - r1^2 + r2^2 - x2^2 + y1^2 - y2^2 - 
      (x1*Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
            8*r^2*y1*y2)])/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
        4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (x2*Sqrt[(-4*x1^3 + 4*x2*x1^2 + 4*r1^2*x1 - 
            4*r2^2*x1 + 4*x2^2*x1 - 4*y1^2*x1 + 4*y2^2*x1 + 
            8*b*y1*x1 - 8*b*y2*x1 - 4*x2^3 - 8*a*y1^2 + 
            4*x2*y1^2 - 8*a*y2^2 - 4*x2*y2^2 - 4*r1^2*x2 + 
            4*r2^2*x2 - 8*b*x2*y1 + 8*b*x2*y2 + 16*a*y1*y2)^
           2 - 4*(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
            4*y2^2 - 8*y1*y2)*(r1^4 - 2*r2^2*r1^2 - 
            2*x1^2*r1^2 + 2*x2^2*r1^2 - 2*y1^2*r1^2 + 
            2*y2^2*r1^2 + 4*b*y1*r1^2 - 4*b*y2*r1^2 + 
            r2^4 + x1^4 + x2^4 + y1^4 + y2^4 - 4*b*y1^3 - 
            4*b*y2^3 + 2*r2^2*x1^2 - 2*r2^2*x2^2 - 
            2*x1^2*x2^2 + 4*a^2*y1^2 + 4*b^2*y1^2 - 
            4*r^2*y1^2 + 2*r2^2*y1^2 + 2*x1^2*y1^2 - 
            2*x2^2*y1^2 + 4*a^2*y2^2 + 4*b^2*y2^2 - 
            4*r^2*y2^2 - 2*r2^2*y2^2 - 2*x1^2*y2^2 + 
            2*x2^2*y2^2 - 2*y1^2*y2^2 + 4*b*y1*y2^2 - 
            4*b*r2^2*y1 - 4*b*x1^2*y1 + 4*b*x2^2*y1 + 
            4*b*r2^2*y2 + 4*b*x1^2*y2 - 4*b*x2^2*y2 + 
            4*b*y1^2*y2 - 8*a^2*y1*y2 - 8*b^2*y1*y2 + 
            8*r^2*y1*y2)])/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 
        4*y1^2 + 4*y2^2 - 8*y1*y2) + (4*r1^2*x1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (4*r2^2*x1^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (4*x1^4)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*r1^2*x1*x2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*r2^2*x1*x2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*x1^3*x2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) + (4*r1^2*x2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (4*r2^2*x2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (8*x1*x2^3)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) + (4*x2^4)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*b*x1^2*y1)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (16*b*x1*x2*y1)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*b*x2^2*y1)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (8*a*x1*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (4*x1^2*y1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (8*a*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*x1*x2*y1^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (4*x2^2*y1^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) - (8*b*x1^2*y2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (16*b*x1*x2*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*b*x2^2*y2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (16*a*x1*y1*y2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) - 
      (16*a*x2*y1*y2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*a*x1*y2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (4*x1^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2) + 
      (8*a*x2*y2^2)/(4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 
        4*y2^2 - 8*y1*y2) - (8*x1*x2*y2^2)/
       (4*x1^2 - 8*x2*x1 + 4*x2^2 + 4*y1^2 + 4*y2^2 - 
        8*y1*y2) + (4*x2^2*y2^2)/(4*x1^2 - 8*x2*x1 + 
        4*x2^2 + 4*y1^2 + 4*y2^2 - 8*y1*y2))}}\
\>", "Output",
 CellChangeTimes->{{3.561499804354885*^9, 3.561499835280571*^9}}]
}, Open  ]]
},
WindowSize->{740, 867},
WindowMargins->{{249, Automatic}, {Automatic, 54}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (October 10, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 1007, 31, 69, "Input"],
Cell[1589, 55, 12357, 232, 3694, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

