(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    340288,       6754]
NotebookOptionsPosition[    339973,       6738]
NotebookOutlinePosition[    340310,       6753]
CellTagsIndexPosition[    340267,       6750]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"r1", "^", "2"}]}], "+", 
         RowBox[{"r2", "^", "2"}], "-", 
         RowBox[{"2", "*", "x", "*", "x1"}], "+", 
         RowBox[{"x1", "^", "2"}], "+", 
         RowBox[{"2", "*", "x", "*", "x2"}], "-", 
         RowBox[{"x2", "^", "2"}], "+", 
         RowBox[{"y1", "^", "2"}], "-", 
         RowBox[{"y2", "^", "2"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{"y1", "-", "y2"}], ")"}]}], ")"}]}], "\[Equal]", "y"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b"}], ")"}], "^", "2"}]}], "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Abs", "[", 
           RowBox[{
            RowBox[{"2", "*", 
             RowBox[{"(", 
              RowBox[{"x2", "-", "x1"}], ")"}], "*", "a"}], "+", 
            RowBox[{"2", "*", 
             RowBox[{"(", 
              RowBox[{"y2", "-", "y1"}], ")"}], "*", "b"}], "+", 
            RowBox[{"r2", "^", "2"}], "-", 
            RowBox[{"r1", "^", "2"}], "+", 
            RowBox[{"x1", "^", "2"}], "-", 
            RowBox[{"x2", "^", "2"}], "+", 
            RowBox[{"y1", "^", "2"}], "-", 
            RowBox[{"y2", "^", "2"}]}], "]"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"x2", "-", "x1"}], ")"}], "^", "2"}]}], "+", 
            RowBox[{"4", "*", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"y2", "-", "y1"}], ")"}], "^", "2"}]}]}], "]"}], 
          ")"}]}], ")"}], "^", "2"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561882826636663*^9, 3.5618828436421022`*^9}, {
  3.561885409575144*^9, 3.56188541237891*^9}, {3.561886018118291*^9, 
  3.5618860292819853`*^9}, {3.5618860811640997`*^9, 3.561886081514627*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"12", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
         RowBox[{"12", "*", 
          RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"12", "*", "x1", "*", 
          RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"16", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", "x1", "*", 
          RowBox[{"y1", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "b", "*", "x2", "*", 
          RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "x1", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "x2", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"24", "*", "b", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], " ", 
         "-", " ", 
         RowBox[{"16", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "+", " ", 
         RowBox[{"32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"16", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"24", "*", "b", "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"32", "*", "a", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", "x2", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"16", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x2", "^", "3"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"48", "*", "a", "*", 
          RowBox[{"y1", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "b", "*", "x1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", "x2", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"32", "*", "a", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "x1", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "x2", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "x1", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "x2", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ",
               "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"16", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"x1", "^", "6"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "x1", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"x2", "^", "6"}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", "y1"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", "y1"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x2", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"y1", "^", "6"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", "y2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", "*", 
               "y2"}], " ", "+", " ", 
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", "*", 
               "y2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"16", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x2", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"16", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"y1", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y1", "^", "3"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", "y1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"y2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "y1", "*", 
               RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"y2", "^", "6"}], " ", "-", " ", "\n", "          ", 
              RowBox[{
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                  "              ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "y1", "*", "y2", "*", "\n", "           ", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", "\n", 
                  "              ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y2", "^", "2"}], "*", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                  "              ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
           RowBox[{"24", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "x1", "*", 
            RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "x1", "*", "x2", "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x2", "^", "2"}], "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
           "\n", "       ", 
           RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
           "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"16", "*", "x1", "*", "x2", "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x2", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"24", "*", 
            RowBox[{"y1", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "y1", "*", 
            RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"y2", "^", "4"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", "y1"}], " ", "-", " ", 
           RowBox[{"2", "*", "y2"}]}], ")"}]}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"r2", "^", "2"}], " ", "+", " ", 
         RowBox[{"x1", "^", "2"}], " ", "-", " ", 
         RowBox[{"x2", "^", "2"}], " ", "+", " ", 
         RowBox[{"y1", "^", "2"}], " ", "-", " ", 
         RowBox[{"y2", "^", "2"}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "x1", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"48", "*", "a", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
                    " ", "-", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"x1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"x2", "^", "6"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "\n", "              ", 
                    "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"24", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", "y1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y2", "^", "6"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                    "                 ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", "y1", "*", "y2", "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", "\n", "                 ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                    RowBox[{"y2", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                    "                 ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}]}], ")"}],
           "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", "\n", 
            "        ", 
            RowBox[{"24", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", 
             RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
            
            RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"16", "*", 
             RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
            
            RowBox[{"16", "*", 
             RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"24", "*", 
             RowBox[{"y1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "y1", "*", 
             RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y2", "^", "4"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "x1", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"48", "*", "a", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
                    " ", "-", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"x1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"x2", "^", "6"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "\n", "              ", 
                    "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"24", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", "y1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y2", "^", "6"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                    "                 ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", "y1", "*", "y2", "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", "\n", "                 ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                    RowBox[{"y2", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                    "                 ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}]}], ")"}],
           "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", "\n", 
            "        ", 
            RowBox[{"24", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", 
             RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
            
            RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"16", "*", 
             RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
            
            RowBox[{"16", "*", 
             RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"24", "*", 
             RowBox[{"y1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "y1", "*", 
             RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y2", "^", "4"}]}]}], ")"}]}]}], ")"}]}]}]}], "}"}], ",",
    " ", "\n", "  ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"12", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
         RowBox[{"12", "*", 
          RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"12", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", 
          RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"12", "*", "x1", "*", 
          RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"16", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", "x1", "*", 
          RowBox[{"y1", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "b", "*", "x2", "*", 
          RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "x1", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "x2", "*", 
          RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"24", "*", "b", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], " ", 
         "-", " ", 
         RowBox[{"16", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "+", " ", 
         RowBox[{"32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"16", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", 
          RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"24", "*", "b", "*", "x2", "*", 
          RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"32", "*", "a", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
         RowBox[{"8", "*", "x1", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
         RowBox[{"8", "*", "x2", "*", 
          RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x1", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"16", "*", "x1", "*", 
          RowBox[{"x2", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"x2", "^", "3"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"48", "*", "a", "*", 
          RowBox[{"y1", "^", "2"}], "*", 
          RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "b", "*", "x1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "b", "*", "x2", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"32", "*", "a", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "x1", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "x2", "*", "y1", "*", 
          RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "x1", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "x2", "*", 
          RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ",
               "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"16", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"x1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"x1", "^", "6"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "x1", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"x2", "^", "6"}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", "y1"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", "y1"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x2", "^", "4"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"y1", "^", "6"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", "y2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", "*", 
               "y2"}], " ", "+", " ", 
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", "*", 
               "y2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"16", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", 
               RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x2", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"12", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"16", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"24", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"y1", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y1", "^", "4"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"a", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"16", "*", 
               RowBox[{"b", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"y1", "^", "3"}], "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"3", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"12", "*", "b", "*", "y1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b", "*", 
               RowBox[{"y2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "y1", "*", 
               RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"y2", "^", "6"}], " ", "-", " ", "\n", "          ", 
              RowBox[{
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                  "              ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "y1", "*", "y2", "*", "\n", "           ", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", "\n", 
                  "              ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"y2", "^", "2"}], "*", 
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                  RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                  "              ", 
                  RowBox[{"2", "*", "a", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                  "+", " ", 
                  RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                  RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                  RowBox[{"2", "*", "b", "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                 "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
           RowBox[{"24", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "x1", "*", 
            RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"x2", "^", "4"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "x1", "*", "x2", "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x2", "^", "2"}], "*", 
            RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
           "\n", "       ", 
           RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
           "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
           RowBox[{"16", "*", 
            RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x1", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"16", "*", "x1", "*", "x2", "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"x2", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"24", "*", 
            RowBox[{"y1", "^", "2"}], "*", 
            RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"16", "*", "y1", "*", 
            RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"y2", "^", "4"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", "y1"}], " ", "-", " ", 
           RowBox[{"2", "*", "y2"}]}], ")"}]}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"r2", "^", "2"}], " ", "+", " ", 
         RowBox[{"x1", "^", "2"}], " ", "-", " ", 
         RowBox[{"x2", "^", "2"}], " ", "+", " ", 
         RowBox[{"y1", "^", "2"}], " ", "-", " ", 
         RowBox[{"y2", "^", "2"}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "x1", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"48", "*", "a", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
                    " ", "-", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"x1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"x2", "^", "6"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "\n", "              ", 
                    "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"24", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", "y1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y2", "^", "6"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                    "                 ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", "y1", "*", "y2", "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", "\n", "                 ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                    RowBox[{"y2", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                    "                 ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}]}], ")"}],
           "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", "\n", 
            "        ", 
            RowBox[{"24", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", 
             RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
            
            RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"16", "*", 
             RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
            
            RowBox[{"16", "*", 
             RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"24", "*", 
             RowBox[{"y1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "y1", "*", 
             RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y2", "^", "4"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x1", "^", "5"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "-", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"12", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"x2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"12", "*", "x1", "*", 
               RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"x2", "^", "5"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"16", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", 
              RowBox[{
              "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", "y2"}], 
              " ", "-", " ", 
              RowBox[{"16", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", "+", 
              " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", 
               RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"32", "*", "a", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", "\n", 
              "         ", 
              RowBox[{"8", "*", "x1", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
              RowBox[{"8", "*", "x2", "*", 
               RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"16", "*", "x1", "*", 
               RowBox[{"x2", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"x2", "^", "3"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"48", "*", "a", "*", 
               RowBox[{"y1", "^", "2"}], "*", 
               RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b", "*", "x1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "b", "*", "x2", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"32", "*", "a", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "x1", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "x2", "*", "y1", "*", 
               RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "x1", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "x2", "*", 
               RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "x1", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "32", "*", "a", "*", "x1", "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", "y1", "*", 
                    "y2"}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "x1", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "a", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", "b", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"24", "*", "b", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"48", "*", "a", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"32", "*", "a", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "x1", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}],
                    " ", "-", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y2", "^", "4"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"x1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "x1", "*", "x2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "5"}], "*", "x2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"x2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", 
                    RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", 
                    RowBox[{"x2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"x2", "^", "6"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "\n", "              ", 
                    "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y1"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y1"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y1", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y1", "^", "6"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", "y1", 
                    "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "4"}], "*", "y1", "*", "y2"}], " ", 
                   "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"y1", "^", "4"}], "*", "y2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"y1", "^", "5"}], "*", "y2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "3"}], "*", "x2", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "x1", "*", 
                    RowBox[{"x2", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"12", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "8", "*", "b", "*", "x1", "*", "x2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"16", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"24", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"24", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "4"}], "*", 
                    RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"16", "*", 
                    RowBox[{"a", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"16", "*", 
                    RowBox[{"b", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x1", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"x2", "^", "2"}], "*", "y1", "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b", "*", 
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"y1", "^", "3"}], "*", 
                    RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"x1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "x1", "*", "x2", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"3", "*", 
                    RowBox[{"x2", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"12", "*", "b", "*", "y1", "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{"y2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "y1", "*", 
                    RowBox[{"y2", "^", "5"}]}], " ", "+", " ", 
                   RowBox[{"y2", "^", "6"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"y1", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", "\n", 
                    "                 ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", "y1", "*", "y2", "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", "\n", "                 ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                    RowBox[{"y2", "^", "2"}], "*", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                    RowBox[{"r2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"x1", "^", "2"}], " ", "-", " ", 
                    RowBox[{"x2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "a", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "x1"}], " ", "+", " ", "x2"}], ")"}]}], " ", 
                    "+", " ", 
                    RowBox[{"y1", "^", "2"}], " ", "-", " ", "\n", 
                    "                 ", 
                    RowBox[{"y2", "^", "2"}], " ", "+", " ", 
                    RowBox[{"2", "*", "b", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "y1"}], " ", "+", " ", "y2"}], ")"}]}]}], 
                    "]"}], "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}]}], ")"}],
           "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"x1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "3"}], "*", "x2"}], " ", "+", " ", "\n", 
            "        ", 
            RowBox[{"24", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"x2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", 
             RowBox[{"x2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"x2", "^", "4"}]}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y1", "^", "4"}]}], " ", "-", " ", 
            RowBox[{"16", "*", 
             RowBox[{"x1", "^", "2"}], "*", "y1", "*", "y2"}], " ", "+", " ", 
            
            RowBox[{"32", "*", "x1", "*", "x2", "*", "y1", "*", "y2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"16", "*", 
             RowBox[{"x2", "^", "2"}], "*", "y1", "*", "y2"}], " ", "-", " ", 
            
            RowBox[{"16", "*", 
             RowBox[{"y1", "^", "3"}], "*", "y2"}], " ", "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"x1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "x1", "*", "x2", "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", 
             RowBox[{"x2", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"24", "*", 
             RowBox[{"y1", "^", "2"}], "*", 
             RowBox[{"y2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"16", "*", "y1", "*", 
             RowBox[{"y2", "^", "3"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"y2", "^", "4"}]}]}], ")"}]}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.561882852521613*^9, 3.561882891989749*^9, 
  3.561885417071739*^9, 3.561886128817986*^9, 3.561886165886821*^9},
 FormatType->"InputForm"]
}, Open  ]]
},
WindowSize->{740, 867},
WindowMargins->{{192, Automatic}, {Automatic, 54}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (October 10, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 2287, 64, 145, "Input"],
Cell[2869, 88, 337088, 6647, 9775, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
