(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[   3803706,      72578]
NotebookOptionsPosition[   3801998,      72520]
NotebookOutlinePosition[   3802335,      72535]
CellTagsIndexPosition[   3802292,      72532]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.561203190587008*^9, 3.561203195256988*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solve", " ", "for", " ", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}], " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r3", "+", "r"}], ")"}], "^", "2"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.561203204052616*^9, 3.5612032040534353`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a1\\)\\) + x)\\)\\^2 + \\((\\(\\(-b1\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203205812687*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a2\\)\\) + x)\\)\\^2 + \\((\\(\\(-b2\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203205827216*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a3\\)\\) + x)\\)\\^2 + \\((\\(\\(-b3\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203205829507*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Set :: \
write\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203205831727*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"for", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r", "+", "r2"}], ")"}], "2"], " ", "solve", " ", "x"}], ",", 
   RowBox[{"for", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r", "+", "r2"}], ")"}], "2"], " ", "solve", " ", "y"}], ",", 
   RowBox[{"for", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r", "+", "r3"}], ")"}], "2"], " ", "solve", " ", "z"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.561203205834146*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solve", " ", "for", " ", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}], " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r2", "+", "z"}], ")"}], "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r2", "+", "z"}], ")"}], "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}]}], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"r3", "+", "z"}], ")"}], "^", "2"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.561203364911001*^9, 3.561203389489147*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a1\\)\\) + x)\\)\\^2 + \\((\\(\\(-b1\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203393256871*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a2\\)\\) + x)\\)\\^2 + \\((\\(\\(-b2\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5612033932588*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(Plus\\)\[NoBreak] in \
\[NoBreak]\\!\\(\\((\\(\\(-a3\\)\\) + x)\\)\\^2 + \\((\\(\\(-b3\\)\\) + y)\\)\
\\^2\\)\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203393261232*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(Set :: \
write\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203393263241*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"for", " ", "solve", " ", "x", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r2", "+", "z"}], ")"}], "2"]}], ",", 
   RowBox[{"for", " ", "solve", " ", "y", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r2", "+", "z"}], ")"}], "2"]}], ",", 
   RowBox[{"for", " ", "solve", " ", "z", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"r3", "+", "z"}], ")"}], "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{3.5612033932659388`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"r3", "+", "r"}], ")"}], "^", "2"}]}]}], "}"}], ".."}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.561203398788642*^9, 3.561203446170813*^9}},
 EmphasizeSyntaxErrors->True],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Syntax", "::", "sntxb"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Expression cannot begin with \
\\\"\[NoBreak]\\!\\(\\([\\(\\(\\(\\(\\(\\({\\(\\(\\(\\(\\(\\((x - a1)\\)\\)^2\
\\)\\) + \\(\\(\\(\\((y - b1)\\)\\)^2\\)\\) - \\(\\(\\(\\((r2 + r)\\)\\)^2\\)\
\\)\\)\\), \\(\\(\\(\\(\\(\\((x - a2)\\)\\)^2\\)\\) + \\(\\(\\(\\((y - b2)\\)\
\\)^2\\)\\) - \\(\\(\\(\\((r2 + r)\\)\\)^2\\)\\)\\)\\), \\(\\(\\(\\(\\(\\((x \
- a3)\\)\\)^2\\)\\) + \\(\\(\\(\\((y - b3)\\)\\)^2\\)\\) - \\(\\(\\(\\((r3 + \
r)\\)\\)^2\\)\\)\\)\\)}\\)\\) ..\\)\\) \\(\\({0, 0, 0}\\)\\)\\)\\)]\\)\\\\ \
\\)\[NoBreak]\\\"\[NoBreak]\\!\\(\\\"\\\"\\)\[NoBreak].\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{3.561203495453679*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Syntax", "::", "sntxb"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Expression cannot begin with \
\\\"\[NoBreak]\\!\\(\\([\\(\\(\\(\\(\\(\\({\\(\\(\\(\\(\\(\\((x - a1)\\)\\)^2\
\\)\\) + \\(\\(\\(\\((y - b1)\\)\\)^2\\)\\) - \\(\\(\\(\\((r2 + r)\\)\\)^2\\)\
\\)\\)\\), \\(\\(\\(\\(\\(\\((x - a2)\\)\\)^2\\)\\) + \\(\\(\\(\\((y - b2)\\)\
\\)^2\\)\\) - \\(\\(\\(\\((r2 + r)\\)\\)^2\\)\\)\\)\\), \\(\\(\\(\\(\\(\\((x \
- a3)\\)\\)^2\\)\\) + \\(\\(\\(\\((y - b3)\\)\\)^2\\)\\) - \\(\\(\\(\\((r3 + \
r)\\)\\)^2\\)\\)\\)\\)}\\)\\) ..\\)\\) \\(\\({0, 0, 0}\\)\\)\\)\\)]\\) \
\[IndentingNewLine]\\)\[NoBreak]\\\"\[NoBreak]\\!\\(\\\"\\\"\\)\[NoBreak].\"\>\
"}]], "Message", "MSG",
 CellChangeTimes->{3.561203495457035*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Syntax", "::", "tsntxi"}], "MessageName"], 
  RowBox[{
  ":", " "}], \
"\<\"\\\"\[NoBreak]\\!\\([\\(\\(\\(\\(\\(\\({\\(\\(\\(\\(\\(\\((x - \
a1)\\)\\)^2\\)\\) + \\(\\(\\(\\((y - b1)\\)\\)^2\\)\\) - \\(\\(\\(\\((r2 + r)\
\\)\\)^2\\)\\)\\)\\), \\(\\(\\(\\(\\(\\((x - a2)\\)\\)^2\\)\\) + \
\\(\\(\\(\\((y - b2)\\)\\)^2\\)\\) - \\(\\(\\(\\((r2 + \
r)\\)\\)^2\\)\\)\\)\\), \\(\\(\\(\\(\\(\\((x - a3)\\)\\)^2\\)\\) + \
\\(\\(\\(\\((y - b3)\\)\\)^2\\)\\) - \\(\\(\\(\\((r3 + \
r)\\)\\)^2\\)\\)\\)\\)}\\)\\) ..\\)\\) \\(\\({0, 0, 0}\\)\\)\\)\\)]\\)\
\[NoBreak]\\\" is incomplete; more input is \
needed.\[NoBreak]\\!\\(\\\"\\\"\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.561203495459812*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Syntax", "::", "sntxi"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Incomplete expression; more input is needed \
\[NoBreak]\\!\\(\\\"\\\"\\)\[NoBreak].\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5612034954621897`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "2"}], "-", 
        RowBox[{"y", "^", "2"}]}], ",", 
       RowBox[{
        RowBox[{"x", "^", "2"}], "+", 
        RowBox[{"y", "^", "2"}]}]}], "}"}], ".."}], 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.561203432418969*^9, 3.561203433633438*^9}, {
  3.5612035125290537`*^9, 3.561203546005457*^9}},
 EmphasizeSyntaxErrors->True],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "^", "2"}], "-", 
       RowBox[{"y", "^", "2"}]}], ",", 
      RowBox[{
       RowBox[{"x", "^", "2"}], "+", 
       RowBox[{"y", "^", "2"}]}]}], "}"}], ".."}], 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561203563862385*^9, 3.561203564357218*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Solve", "::", "naqs"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(0 && 0\\)\[NoBreak] is not a quantified \
system of equations and inequalities. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Solve\\\", ButtonNote -> \\\"Solve::naqs\\\"]\\)\"\
\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5612035676941547`*^9}],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.561203567696018*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", " ", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "2"}], "-", 
        RowBox[{"y", "^", "2"}]}], "\[Equal]", "a2"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"x", "^", "2"}], "+", 
        RowBox[{"y", "^", "2"}]}], "\[Equal]", "a1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.561203617601433*^9, 3.5612036921799507`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      RowBox[{"-", 
       FractionBox[
        SqrtBox[
         RowBox[{"a1", "+", "a2"}]], 
        SqrtBox["2"]]}]}], ",", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{"-", 
       FractionBox[
        SqrtBox[
         RowBox[{"a1", "-", "a2"}]], 
        SqrtBox["2"]]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      RowBox[{"-", 
       FractionBox[
        SqrtBox[
         RowBox[{"a1", "+", "a2"}]], 
        SqrtBox["2"]]}]}], ",", 
     RowBox[{"y", "\[Rule]", 
      FractionBox[
       SqrtBox[
        RowBox[{"a1", "-", "a2"}]], 
       SqrtBox["2"]]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      FractionBox[
       SqrtBox[
        RowBox[{"a1", "+", "a2"}]], 
       SqrtBox["2"]]}], ",", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{"-", 
       FractionBox[
        SqrtBox[
         RowBox[{"a1", "-", "a2"}]], 
        SqrtBox["2"]]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      FractionBox[
       SqrtBox[
        RowBox[{"a1", "+", "a2"}]], 
       SqrtBox["2"]]}], ",", 
     RowBox[{"y", "\[Rule]", 
      FractionBox[
       SqrtBox[
        RowBox[{"a1", "-", "a2"}]], 
       SqrtBox["2"]]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5612036966242647`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r3", "+", "r"}], ")"}], "^", "2"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "r"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561203716004504*^9, 3.561203751721613*^9}}],

Cell["\<\
{{x -> (4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
      4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
      4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
      4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 4*a3*b1*b2*a1^2 + 
      4*a2*b1*b3*a1^2 - 4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
      4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
      4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
      4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
      8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 4*a2^2*r2^2*a1 - 
      4*b1^2*r2^2*a1 + 4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
      4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 4*b1^2*r3^2*a1 + 
      4*b1*b2*r3^2*a1 + 4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
      4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
      4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 4*a3^2*b1*b3*a1 + 
      4*a2^2*b2*b3*a1 + 4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
      8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
      8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
      8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
      4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
      4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
      4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
      8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
      4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 8*a3*b1*b2*b3^2 - 
      4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 4*a2*b2^2*r2^2 - 
      4*a3*b2^2*r2^2 + 4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
      4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
      4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
      4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 4*a2*b1*b3*r3^2 + 
      4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 4*a3*b1^3*b2 - 
      8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 4*a2^2*a3*b1*b2 + 
      4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 4*a3*b2^3*b3 - 
      8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 8*a2^3*b1*b3 + 
      4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 4*a2*a3^2*b2*b3 + 
      4*a2*b1^2*b2*b3 + 4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 
      8*a2^3*r2*r3 + 8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
      8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
      16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
      8*a2*b2*b3*r2*r3 - 
      Sqrt[(-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
          4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
          4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
          4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
          4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
          4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
          4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
          8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 4*b1*b3^3*a1 - 
          4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 4*b1^2*b2^2*a1 + 
          4*a2^2*b3^2*a1 - 4*b1^2*b3^2*a1 + 
          8*b2^2*b3^2*a1 - 4*b1*b2*b3^2*a1 - 
          4*a2^2*r2^2*a1 + 4*b1^2*r2^2*a1 - 
          4*b1*b2*r2^2*a1 - 4*b1*b3*r2^2*a1 + 
          4*b2*b3*r2^2*a1 - 4*a2^2*r3^2*a1 + 
          4*b1^2*r3^2*a1 - 4*b1*b2*r3^2*a1 - 
          4*b1*b3*r3^2*a1 + 4*b2*b3*r3^2*a1 + 
          4*a2^2*b1*b2*a1 - 4*a3^2*b1*b2*a1 - 
          4*b2^3*b3*a1 - 4*b1*b2^2*b3*a1 - 4*a2^2*b1*b3*
           a1 + 4*a3^2*b1*b3*a1 - 4*a2^2*b2*b3*a1 - 
          4*a3^2*b2*b3*a1 + 8*b1^2*b2*b3*a1 + 
          8*a2^2*r2*r3*a1 - 8*b1^2*r2*r3*a1 + 
          8*b1*b2*r2*r3*a1 + 8*b1*b3*r2*r3*a1 - 
          8*b2*b3*r2*r3*a1 - 4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 
          4*a2*b2*b3^3 - 4*a2^3*b1^2 - 4*a3^3*b1^2 + 
          4*a2*a3^2*b1^2 + 4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 
          4*a2*b1^2*b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
          8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
          4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
          4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 4*a2^3*r2^2 + 
          4*a3*b1^2*r2^2 + 4*a2*b2^2*r2^2 + 
          4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
          8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
          4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*r3^2 + 
          4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
          4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
          4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
          4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
          4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
          4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
          8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
          8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
           b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
          4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
          8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
           r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
          16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
          8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
          4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
          8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
          8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
          8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
          8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
          16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
          8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
          4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
          8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
          4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
          8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
          8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
          8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*(b2^2*a1^4 + 
          b3^2*a1^4 - r2^2*a1^4 - r3^2*a1^4 - 
          2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 2*b1*b2^3*a1^2 - 
          2*b1*b3^3*a1^2 + 2*b2*b3^3*a1^2 - 
          2*a3^2*b2^2*a1^2 + 2*b1^2*b2^2*a1^2 - 
          2*a2^2*b3^2*a1^2 + 2*b1^2*b3^2*a1^2 - 
          4*b2^2*b3^2*a1^2 + 2*b1*b2*b3^2*a1^2 + 
          2*a2^2*r2^2*a1^2 - 2*b1^2*r2^2*a1^2 + 
          2*b1*b2*r2^2*a1^2 + 2*b1*b3*r2^2*a1^2 - 
          2*b2*b3*r2^2*a1^2 + 2*a2^2*r3^2*a1^2 - 
          2*b1^2*r3^2*a1^2 + 2*b1*b2*r3^2*a1^2 + 
          2*b1*b3*r3^2*a1^2 - 2*b2*b3*r3^2*a1^2 - 
          2*a2^2*b1*b2*a1^2 + 2*a3^2*b1*b2*a1^2 + 
          2*b2^3*b3*a1^2 + 2*b1*b2^2*b3*a1^2 + 
          2*a2^2*b1*b3*a1^2 - 2*a3^2*b1*b3*a1^2 + 
          2*a2^2*b2*b3*a1^2 + 2*a3^2*b2*b3*a1^2 - 
          4*b1^2*b2*b3*a1^2 - 4*a2^2*r2*r3*a1^2 + 
          4*b1^2*r2*r3*a1^2 - 4*b1*b2*r2*r3*a1^2 - 
          4*b1*b3*r2*r3*a1^2 + 4*b2*b3*r2*r3*a1^2 + 
          b1^2*b2^4 + b1^2*b3^4 + b2^2*b3^4 - 
          2*b1*b2*b3^4 + b1^2*r2^4 + b2^2*r2^4 - 
          2*b1*b2*r2^4 + b1^2*r3^4 + b2^2*r3^4 - 
          2*b1*b2*r3^4 - 2*b1^3*b2^3 + 2*a3^2*b1*b2^3 - 
          2*b1^3*b3^3 - 2*b2^3*b3^3 + 2*b1*b2^2*b3^3 + 
          2*a2^2*b1*b3^3 - 2*a2^2*b2*b3^3 + 
          2*b1^2*b2*b3^3 - 4*b1^2*r2*r3^3 - 
          4*b2^2*r2*r3^3 + 8*b1*b2*r2*r3^3 + a2^4*b1^2 + 
          a3^4*b1^2 - 2*a2^2*a3^2*b1^2 + a3^4*b2^2 + 
          b1^4*b2^2 + 2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
          a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
          2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
          2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
          2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
          2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
          4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
          b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*r2^2 - 
          2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
          2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
          2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
          2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
          4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
          2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
          2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
          2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
          b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*r3^2 - 
          2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
          2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
          2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
          6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
          12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
          2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
          2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
          2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
          2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
          2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 2*a3^4*b1*b2 + 
          2*a2^2*a3^2*b1*b2 - 2*b1*b2^4*b3 + 
          2*a2^2*b1^3*b3 - 2*a3^2*b1^3*b3 - 
          2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
          2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
          2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
          2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
          2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
          2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
          4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 2*a2^4*r2*r3 + 
          2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 4*b1*b2^3*r2*r3 + 
          4*a3^2*b1^2*r2*r3 + 4*a2^2*b2^2*r2*r3 + 
          4*a3^2*b2^2*r2*r3 + 4*b1^2*b2^2*r2*r3 + 
          4*b1^2*b3^2*r2*r3 + 4*b2^2*b3^2*r2*r3 - 
          8*b1*b2*b3^2*r2*r3 - 4*b1^3*b2*r2*r3 - 
          4*a2^2*b1*b2*r2*r3 - 8*a3^2*b1*b2*r2*r3 - 
          4*b1^3*b3*r2*r3 - 4*b2^3*b3*r2*r3 + 
          4*b1*b2^2*b3*r2*r3 + 4*a2^2*b1*b3*r2*r3 - 
          4*a2^2*b2*b3*r2*r3 + 4*b1^2*b2*b3*r2*r3)])/
     (2*(4*b2^2*a1^2 + 4*b3^2*a1^2 - 4*r2^2*a1^2 - 
       4*r3^2*a1^2 - 8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 
       8*a3*b2^2*a1 - 8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 
       8*a2*r3^2*a1 - 8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 
       8*a2*b1*b3*a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
       8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
       4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
       4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
       4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
       4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
       8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
       8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
       8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)), 
   y -> (1/(2*b2 - 2*b1))*(-a1^2 + a2^2 - b1^2 + b2^2 + 
      (a1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3)), 
   r -> (b2*a1^2 - b3*a1^2 - b1*b2^2 + b1*b3^2 - b2*b3^2 + 
      b1*r2^2 - b2*r2^2 - b1*r3^2 + b2*r3^2 + a3^2*b1 - 
      a2^2*b1 - a3^2*b2 + b1^2*b2 + a2^2*b3 - b1^2*b3 + 
      b2^2*b3 + (a2*b1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 
         4*r2^2*a1^3 - 4*r3^2*a1^3 - 8*b2*b3*a1^3 + 
         8*r2*r3*a1^3 - 4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 
         4*a2*r2^2*a1^2 + 4*a2*r3^2*a1^2 - 
         4*a2*b1*b2*a1^2 + 4*a3*b1*b2*a1^2 + 
         4*a2*b1*b3*a1^2 - 4*a3*b1*b3*a1^2 + 
         4*a2*b2*b3*a1^2 + 4*a3*b2*b3*a1^2 - 
         8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 4*b1*b3^3*a1 + 
         4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 4*b1^2*b2^2*a1 - 
         4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 8*b2^2*b3^2*a1 + 
         4*b1*b2*b3^2*a1 + 4*a2^2*r2^2*a1 - 
         4*b1^2*r2^2*a1 + 4*b1*b2*r2^2*a1 + 
         4*b1*b3*r2^2*a1 - 4*b2*b3*r2^2*a1 + 
         4*a2^2*r3^2*a1 - 4*b1^2*r3^2*a1 + 
         4*b1*b2*r3^2*a1 + 4*b1*b3*r3^2*a1 - 
         4*b2*b3*r3^2*a1 - 4*a2^2*b1*b2*a1 + 
         4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 4*b1*b2^2*b3*a1 + 
         4*a2^2*b1*b3*a1 - 4*a3^2*b1*b3*a1 + 
         4*a2^2*b2*b3*a1 + 4*a3^2*b2*b3*a1 - 
         8*b1^2*b2*b3*a1 - 8*a2^2*r2*r3*a1 + 
         8*b1^2*r2*r3*a1 - 8*b1*b2*r2*r3*a1 - 
         8*b1*b3*r2*r3*a1 + 8*b2*b3*r2*r3*a1 + 
         4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 4*a2*b2*b3^3 + 
         4*a2^3*b1^2 + 4*a3^3*b1^2 - 4*a2*a3^2*b1^2 - 
         4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 4*a2*b1^2*b2^2 - 
         8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 8*a2*b1^2*b3^2 + 
         4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 4*a3*b2^2*b3^2 + 
         4*a2*b1*b2*b3^2 - 8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 
         4*a3*b1^2*r2^2 - 4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a3*b1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a1*b2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) + 
      (a3*b2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) + 
      (a1*b3*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a2*b3*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 - Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3))/
     (-2*b1*r2 + 2*b2*r2 + 2*b1*r3 - 2*b2*r3)}, 
  {x -> (4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
      4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
      4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
      4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 4*a3*b1*b2*a1^2 + 
      4*a2*b1*b3*a1^2 - 4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
      4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
      4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
      4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
      8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 4*a2^2*r2^2*a1 - 
      4*b1^2*r2^2*a1 + 4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
      4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 4*b1^2*r3^2*a1 + 
      4*b1*b2*r3^2*a1 + 4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
      4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
      4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 4*a3^2*b1*b3*a1 + 
      4*a2^2*b2*b3*a1 + 4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
      8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
      8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
      8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
      4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
      4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
      4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
      8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
      4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 8*a3*b1*b2*b3^2 - 
      4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 4*a2*b2^2*r2^2 - 
      4*a3*b2^2*r2^2 + 4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
      4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
      4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
      4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 4*a2*b1*b3*r3^2 + 
      4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 4*a3*b1^3*b2 - 
      8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 4*a2^2*a3*b1*b2 + 
      4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 4*a3*b2^3*b3 - 
      8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 8*a2^3*b1*b3 + 
      4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 4*a2*a3^2*b2*b3 + 
      4*a2*b1^2*b2*b3 + 4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 
      8*a2^3*r2*r3 + 8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
      8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
      16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
      8*a2*b2*b3*r2*r3 + 
      Sqrt[(-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
          4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
          4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
          4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
          4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
          4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
          4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
          8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 4*b1*b3^3*a1 - 
          4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 4*b1^2*b2^2*a1 + 
          4*a2^2*b3^2*a1 - 4*b1^2*b3^2*a1 + 
          8*b2^2*b3^2*a1 - 4*b1*b2*b3^2*a1 - 
          4*a2^2*r2^2*a1 + 4*b1^2*r2^2*a1 - 
          4*b1*b2*r2^2*a1 - 4*b1*b3*r2^2*a1 + 
          4*b2*b3*r2^2*a1 - 4*a2^2*r3^2*a1 + 
          4*b1^2*r3^2*a1 - 4*b1*b2*r3^2*a1 - 
          4*b1*b3*r3^2*a1 + 4*b2*b3*r3^2*a1 + 
          4*a2^2*b1*b2*a1 - 4*a3^2*b1*b2*a1 - 
          4*b2^3*b3*a1 - 4*b1*b2^2*b3*a1 - 4*a2^2*b1*b3*
           a1 + 4*a3^2*b1*b3*a1 - 4*a2^2*b2*b3*a1 - 
          4*a3^2*b2*b3*a1 + 8*b1^2*b2*b3*a1 + 
          8*a2^2*r2*r3*a1 - 8*b1^2*r2*r3*a1 + 
          8*b1*b2*r2*r3*a1 + 8*b1*b3*r2*r3*a1 - 
          8*b2*b3*r2*r3*a1 - 4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 
          4*a2*b2*b3^3 - 4*a2^3*b1^2 - 4*a3^3*b1^2 + 
          4*a2*a3^2*b1^2 + 4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 
          4*a2*b1^2*b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
          8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
          4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
          4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 4*a2^3*r2^2 + 
          4*a3*b1^2*r2^2 + 4*a2*b2^2*r2^2 + 
          4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
          8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
          4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*r3^2 + 
          4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
          4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
          4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
          4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
          4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
          4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
          8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
          8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
           b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
          4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
          8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
           r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
          16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
          8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
          4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
          8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
          8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
          8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
          8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
          16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
          8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
          4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
          8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
          4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
          8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
          8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
          8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*(b2^2*a1^4 + 
          b3^2*a1^4 - r2^2*a1^4 - r3^2*a1^4 - 
          2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 2*b1*b2^3*a1^2 - 
          2*b1*b3^3*a1^2 + 2*b2*b3^3*a1^2 - 
          2*a3^2*b2^2*a1^2 + 2*b1^2*b2^2*a1^2 - 
          2*a2^2*b3^2*a1^2 + 2*b1^2*b3^2*a1^2 - 
          4*b2^2*b3^2*a1^2 + 2*b1*b2*b3^2*a1^2 + 
          2*a2^2*r2^2*a1^2 - 2*b1^2*r2^2*a1^2 + 
          2*b1*b2*r2^2*a1^2 + 2*b1*b3*r2^2*a1^2 - 
          2*b2*b3*r2^2*a1^2 + 2*a2^2*r3^2*a1^2 - 
          2*b1^2*r3^2*a1^2 + 2*b1*b2*r3^2*a1^2 + 
          2*b1*b3*r3^2*a1^2 - 2*b2*b3*r3^2*a1^2 - 
          2*a2^2*b1*b2*a1^2 + 2*a3^2*b1*b2*a1^2 + 
          2*b2^3*b3*a1^2 + 2*b1*b2^2*b3*a1^2 + 
          2*a2^2*b1*b3*a1^2 - 2*a3^2*b1*b3*a1^2 + 
          2*a2^2*b2*b3*a1^2 + 2*a3^2*b2*b3*a1^2 - 
          4*b1^2*b2*b3*a1^2 - 4*a2^2*r2*r3*a1^2 + 
          4*b1^2*r2*r3*a1^2 - 4*b1*b2*r2*r3*a1^2 - 
          4*b1*b3*r2*r3*a1^2 + 4*b2*b3*r2*r3*a1^2 + 
          b1^2*b2^4 + b1^2*b3^4 + b2^2*b3^4 - 
          2*b1*b2*b3^4 + b1^2*r2^4 + b2^2*r2^4 - 
          2*b1*b2*r2^4 + b1^2*r3^4 + b2^2*r3^4 - 
          2*b1*b2*r3^4 - 2*b1^3*b2^3 + 2*a3^2*b1*b2^3 - 
          2*b1^3*b3^3 - 2*b2^3*b3^3 + 2*b1*b2^2*b3^3 + 
          2*a2^2*b1*b3^3 - 2*a2^2*b2*b3^3 + 
          2*b1^2*b2*b3^3 - 4*b1^2*r2*r3^3 - 
          4*b2^2*r2*r3^3 + 8*b1*b2*r2*r3^3 + a2^4*b1^2 + 
          a3^4*b1^2 - 2*a2^2*a3^2*b1^2 + a3^4*b2^2 + 
          b1^4*b2^2 + 2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
          a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
          2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
          2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
          2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
          2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
          4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
          b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*r2^2 - 
          2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
          2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
          2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
          2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
          4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
          2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
          2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
          2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
          b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*r3^2 - 
          2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
          2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
          2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
          6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
          12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
          2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
          2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
          2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
          2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
          2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 2*a3^4*b1*b2 + 
          2*a2^2*a3^2*b1*b2 - 2*b1*b2^4*b3 + 
          2*a2^2*b1^3*b3 - 2*a3^2*b1^3*b3 - 
          2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
          2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
          2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
          2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
          2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
          2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
          4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 2*a2^4*r2*r3 + 
          2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 4*b1*b2^3*r2*r3 + 
          4*a3^2*b1^2*r2*r3 + 4*a2^2*b2^2*r2*r3 + 
          4*a3^2*b2^2*r2*r3 + 4*b1^2*b2^2*r2*r3 + 
          4*b1^2*b3^2*r2*r3 + 4*b2^2*b3^2*r2*r3 - 
          8*b1*b2*b3^2*r2*r3 - 4*b1^3*b2*r2*r3 - 
          4*a2^2*b1*b2*r2*r3 - 8*a3^2*b1*b2*r2*r3 - 
          4*b1^3*b3*r2*r3 - 4*b2^3*b3*r2*r3 + 
          4*b1*b2^2*b3*r2*r3 + 4*a2^2*b1*b3*r2*r3 - 
          4*a2^2*b2*b3*r2*r3 + 4*b1^2*b2*b3*r2*r3)])/
     (2*(4*b2^2*a1^2 + 4*b3^2*a1^2 - 4*r2^2*a1^2 - 
       4*r3^2*a1^2 - 8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 
       8*a3*b2^2*a1 - 8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 
       8*a2*r3^2*a1 - 8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 
       8*a2*b1*b3*a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
       8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
       4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
       4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
       4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
       4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
       8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
       8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
       8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)), 
   y -> (1/(2*b2 - 2*b1))*(-a1^2 + a2^2 - b1^2 + b2^2 + 
      (a1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3)), 
   r -> (b2*a1^2 - b3*a1^2 - b1*b2^2 + b1*b3^2 - b2*b3^2 + 
      b1*r2^2 - b2*r2^2 - b1*r3^2 + b2*r3^2 + a3^2*b1 - 
      a2^2*b1 - a3^2*b2 + b1^2*b2 + a2^2*b3 - b1^2*b3 + 
      b2^2*b3 + (a2*b1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 
         4*r2^2*a1^3 - 4*r3^2*a1^3 - 8*b2*b3*a1^3 + 
         8*r2*r3*a1^3 - 4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 
         4*a2*r2^2*a1^2 + 4*a2*r3^2*a1^2 - 
         4*a2*b1*b2*a1^2 + 4*a3*b1*b2*a1^2 + 
         4*a2*b1*b3*a1^2 - 4*a3*b1*b3*a1^2 + 
         4*a2*b2*b3*a1^2 + 4*a3*b2*b3*a1^2 - 
         8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 4*b1*b3^3*a1 + 
         4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 4*b1^2*b2^2*a1 - 
         4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 8*b2^2*b3^2*a1 + 
         4*b1*b2*b3^2*a1 + 4*a2^2*r2^2*a1 - 
         4*b1^2*r2^2*a1 + 4*b1*b2*r2^2*a1 + 
         4*b1*b3*r2^2*a1 - 4*b2*b3*r2^2*a1 + 
         4*a2^2*r3^2*a1 - 4*b1^2*r3^2*a1 + 
         4*b1*b2*r3^2*a1 + 4*b1*b3*r3^2*a1 - 
         4*b2*b3*r3^2*a1 - 4*a2^2*b1*b2*a1 + 
         4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 4*b1*b2^2*b3*a1 + 
         4*a2^2*b1*b3*a1 - 4*a3^2*b1*b3*a1 + 
         4*a2^2*b2*b3*a1 + 4*a3^2*b2*b3*a1 - 
         8*b1^2*b2*b3*a1 - 8*a2^2*r2*r3*a1 + 
         8*b1^2*r2*r3*a1 - 8*b1*b2*r2*r3*a1 - 
         8*b1*b3*r2*r3*a1 + 8*b2*b3*r2*r3*a1 + 
         4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 4*a2*b2*b3^3 + 
         4*a2^3*b1^2 + 4*a3^3*b1^2 - 4*a2*a3^2*b1^2 - 
         4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 4*a2*b1^2*b2^2 - 
         8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 8*a2*b1^2*b3^2 + 
         4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 4*a3*b2^2*b3^2 + 
         4*a2*b1*b2*b3^2 - 8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 
         4*a3*b1^2*r2^2 - 4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a3*b1*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a1*b2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) + 
      (a3*b2*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) + 
      (a1*b3*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3) - 
      (a2*b3*(4*b2^2*a1^3 + 4*b3^2*a1^3 - 4*r2^2*a1^3 - 
         4*r3^2*a1^3 - 8*b2*b3*a1^3 + 8*r2*r3*a1^3 - 
         4*a3*b2^2*a1^2 - 4*a2*b3^2*a1^2 + 4*a2*r2^2*a1^2 + 
         4*a2*r3^2*a1^2 - 4*a2*b1*b2*a1^2 + 
         4*a3*b1*b2*a1^2 + 4*a2*b1*b3*a1^2 - 
         4*a3*b1*b3*a1^2 + 4*a2*b2*b3*a1^2 + 
         4*a3*b2*b3*a1^2 - 8*a2*r2*r3*a1^2 - 4*b1*b2^3*a1 - 
         4*b1*b3^3*a1 + 4*b2*b3^3*a1 - 4*a3^2*b2^2*a1 + 
         4*b1^2*b2^2*a1 - 4*a2^2*b3^2*a1 + 4*b1^2*b3^2*a1 - 
         8*b2^2*b3^2*a1 + 4*b1*b2*b3^2*a1 + 
         4*a2^2*r2^2*a1 - 4*b1^2*r2^2*a1 + 
         4*b1*b2*r2^2*a1 + 4*b1*b3*r2^2*a1 - 
         4*b2*b3*r2^2*a1 + 4*a2^2*r3^2*a1 - 
         4*b1^2*r3^2*a1 + 4*b1*b2*r3^2*a1 + 
         4*b1*b3*r3^2*a1 - 4*b2*b3*r3^2*a1 - 
         4*a2^2*b1*b2*a1 + 4*a3^2*b1*b2*a1 + 4*b2^3*b3*a1 + 
         4*b1*b2^2*b3*a1 + 4*a2^2*b1*b3*a1 - 
         4*a3^2*b1*b3*a1 + 4*a2^2*b2*b3*a1 + 
         4*a3^2*b2*b3*a1 - 8*b1^2*b2*b3*a1 - 
         8*a2^2*r2*r3*a1 + 8*b1^2*r2*r3*a1 - 
         8*b1*b2*r2*r3*a1 - 8*b1*b3*r2*r3*a1 + 
         8*b2*b3*r2*r3*a1 + 4*a3*b1*b2^3 + 4*a2*b1*b3^3 - 
         4*a2*b2*b3^3 + 4*a2^3*b1^2 + 4*a3^3*b1^2 - 
         4*a2*a3^2*b1^2 - 4*a2^2*a3*b1^2 + 4*a3^3*b2^2 + 
         4*a2*b1^2*b2^2 - 8*a3*b1^2*b2^2 + 4*a2^3*b3^2 - 
         8*a2*b1^2*b3^2 + 4*a3*b1^2*b3^2 + 4*a2*b2^2*b3^2 + 
         4*a3*b2^2*b3^2 + 4*a2*b1*b2*b3^2 - 
         8*a3*b1*b2*b3^2 - 4*a2^3*r2^2 - 4*a3*b1^2*r2^2 - 
         4*a2*b2^2*r2^2 - 4*a3*b2^2*r2^2 + 
         4*a2*b1*b2*r2^2 + 8*a3*b1*b2*r2^2 - 
         4*a2*b1*b3*r2^2 + 4*a2*b2*b3*r2^2 - 4*a2^3*r3^2 - 
         4*a3*b1^2*r3^2 - 4*a2*b2^2*r3^2 - 4*a3*b2^2*r3^2 + 
         4*a2*b1*b2*r3^2 + 8*a3*b1*b2*r3^2 - 
         4*a2*b1*b3*r3^2 + 4*a2*b2*b3*r3^2 - 4*a2*b1^3*b2 + 
         4*a3*b1^3*b2 - 8*a3^3*b1*b2 + 4*a2*a3^2*b1*b2 + 
         4*a2^2*a3*b1*b2 + 4*a2*b1^3*b3 - 4*a3*b1^3*b3 - 
         4*a3*b2^3*b3 - 8*a2*b1*b2^2*b3 + 4*a3*b1*b2^2*b3 - 
         8*a2^3*b1*b3 + 4*a2*a3^2*b1*b3 + 4*a2^2*a3*b1*b3 - 
         4*a2*a3^2*b2*b3 + 4*a2*b1^2*b2*b3 + 
         4*a3*b1^2*b2*b3 - 4*a2^2*a3*b2*b3 + 8*a2^3*r2*r3 + 
         8*a3*b1^2*r2*r3 + 8*a2*b2^2*r2*r3 + 
         8*a3*b2^2*r2*r3 - 8*a2*b1*b2*r2*r3 - 
         16*a3*b1*b2*r2*r3 + 8*a2*b1*b3*r2*r3 - 
         8*a2*b2*b3*r2*r3 + Sqrt[
          (-4*b2^2*a1^3 - 4*b3^2*a1^3 + 4*r2^2*a1^3 + 
             4*r3^2*a1^3 + 8*b2*b3*a1^3 - 8*r2*r3*a1^3 + 
             4*a3*b2^2*a1^2 + 4*a2*b3^2*a1^2 - 
             4*a2*r2^2*a1^2 - 4*a2*r3^2*a1^2 + 
             4*a2*b1*b2*a1^2 - 4*a3*b1*b2*a1^2 - 
             4*a2*b1*b3*a1^2 + 4*a3*b1*b3*a1^2 - 
             4*a2*b2*b3*a1^2 - 4*a3*b2*b3*a1^2 + 
             8*a2*r2*r3*a1^2 + 4*b1*b2^3*a1 + 
             4*b1*b3^3*a1 - 4*b2*b3^3*a1 + 4*a3^2*b2^2*a1 - 
             4*b1^2*b2^2*a1 + 4*a2^2*b3^2*a1 - 
             4*b1^2*b3^2*a1 + 8*b2^2*b3^2*a1 - 
             4*b1*b2*b3^2*a1 - 4*a2^2*r2^2*a1 + 
             4*b1^2*r2^2*a1 - 4*b1*b2*r2^2*a1 - 
             4*b1*b3*r2^2*a1 + 4*b2*b3*r2^2*a1 - 
             4*a2^2*r3^2*a1 + 4*b1^2*r3^2*a1 - 
             4*b1*b2*r3^2*a1 - 4*b1*b3*r3^2*a1 + 
             4*b2*b3*r3^2*a1 + 4*a2^2*b1*b2*a1 - 
             4*a3^2*b1*b2*a1 - 4*b2^3*b3*a1 - 4*b1*b2^2*b3*
              a1 - 4*a2^2*b1*b3*a1 + 4*a3^2*b1*b3*a1 - 
             4*a2^2*b2*b3*a1 - 4*a3^2*b2*b3*a1 + 
             8*b1^2*b2*b3*a1 + 8*a2^2*r2*r3*a1 - 
             8*b1^2*r2*r3*a1 + 8*b1*b2*r2*r3*a1 + 
             8*b1*b3*r2*r3*a1 - 8*b2*b3*r2*r3*a1 - 
             4*a3*b1*b2^3 - 4*a2*b1*b3^3 + 4*a2*b2*b3^3 - 
             4*a2^3*b1^2 - 4*a3^3*b1^2 + 4*a2*a3^2*b1^2 + 
             4*a2^2*a3*b1^2 - 4*a3^3*b2^2 - 4*a2*b1^2*
              b2^2 + 8*a3*b1^2*b2^2 - 4*a2^3*b3^2 + 
             8*a2*b1^2*b3^2 - 4*a3*b1^2*b3^2 - 
             4*a2*b2^2*b3^2 - 4*a3*b2^2*b3^2 - 
             4*a2*b1*b2*b3^2 + 8*a3*b1*b2*b3^2 + 
             4*a2^3*r2^2 + 4*a3*b1^2*r2^2 + 4*a2*b2^2*
              r2^2 + 4*a3*b2^2*r2^2 - 4*a2*b1*b2*r2^2 - 
             8*a3*b1*b2*r2^2 + 4*a2*b1*b3*r2^2 - 
             4*a2*b2*b3*r2^2 + 4*a2^3*r3^2 + 4*a3*b1^2*
              r3^2 + 4*a2*b2^2*r3^2 + 4*a3*b2^2*r3^2 - 
             4*a2*b1*b2*r3^2 - 8*a3*b1*b2*r3^2 + 
             4*a2*b1*b3*r3^2 - 4*a2*b2*b3*r3^2 + 
             4*a2*b1^3*b2 - 4*a3*b1^3*b2 + 8*a3^3*b1*b2 - 
             4*a2*a3^2*b1*b2 - 4*a2^2*a3*b1*b2 - 
             4*a2*b1^3*b3 + 4*a3*b1^3*b3 + 4*a3*b2^3*b3 + 
             8*a2*b1*b2^2*b3 - 4*a3*b1*b2^2*b3 + 
             8*a2^3*b1*b3 - 4*a2*a3^2*b1*b3 - 4*a2^2*a3*b1*
              b3 + 4*a2*a3^2*b2*b3 - 4*a2*b1^2*b2*b3 - 
             4*a3*b1^2*b2*b3 + 4*a2^2*a3*b2*b3 - 
             8*a2^3*r2*r3 - 8*a3*b1^2*r2*r3 - 8*a2*b2^2*r2*
              r3 - 8*a3*b2^2*r2*r3 + 8*a2*b1*b2*r2*r3 + 
             16*a3*b1*b2*r2*r3 - 8*a2*b1*b3*r2*r3 + 
             8*a2*b2*b3*r2*r3)^2 - 4*(4*b2^2*a1^2 + 
             4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
             8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
             8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
             8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*
              a1 - 8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 
             8*a3*b2*b3*a1 - 16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 
             4*a3^2*b1^2 - 8*a2*a3*b1^2 + 4*a3^2*b2^2 + 
             4*a2^2*b3^2 - 4*a2^2*r2^2 - 4*b1^2*r2^2 - 
             4*b2^2*r2^2 + 8*b1*b2*r2^2 - 4*a2^2*r3^2 - 
             4*b1^2*r3^2 - 4*b2^2*r3^2 + 8*b1*b2*r3^2 - 
             8*a3^2*b1*b2 + 8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 
             8*a2*a3*b1*b3 - 8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 
             8*b1^2*r2*r3 + 8*b2^2*r2*r3 - 16*b1*b2*r2*r3)*
            (b2^2*a1^4 + b3^2*a1^4 - r2^2*a1^4 - 
             r3^2*a1^4 - 2*b2*b3*a1^4 + 2*r2*r3*a1^4 - 
             2*b1*b2^3*a1^2 - 2*b1*b3^3*a1^2 + 
             2*b2*b3^3*a1^2 - 2*a3^2*b2^2*a1^2 + 
             2*b1^2*b2^2*a1^2 - 2*a2^2*b3^2*a1^2 + 
             2*b1^2*b3^2*a1^2 - 4*b2^2*b3^2*a1^2 + 
             2*b1*b2*b3^2*a1^2 + 2*a2^2*r2^2*a1^2 - 
             2*b1^2*r2^2*a1^2 + 2*b1*b2*r2^2*a1^2 + 
             2*b1*b3*r2^2*a1^2 - 2*b2*b3*r2^2*a1^2 + 
             2*a2^2*r3^2*a1^2 - 2*b1^2*r3^2*a1^2 + 
             2*b1*b2*r3^2*a1^2 + 2*b1*b3*r3^2*a1^2 - 
             2*b2*b3*r3^2*a1^2 - 2*a2^2*b1*b2*a1^2 + 
             2*a3^2*b1*b2*a1^2 + 2*b2^3*b3*a1^2 + 
             2*b1*b2^2*b3*a1^2 + 2*a2^2*b1*b3*a1^2 - 
             2*a3^2*b1*b3*a1^2 + 2*a2^2*b2*b3*a1^2 + 
             2*a3^2*b2*b3*a1^2 - 4*b1^2*b2*b3*a1^2 - 
             4*a2^2*r2*r3*a1^2 + 4*b1^2*r2*r3*a1^2 - 
             4*b1*b2*r2*r3*a1^2 - 4*b1*b3*r2*r3*a1^2 + 
             4*b2*b3*r2*r3*a1^2 + b1^2*b2^4 + b1^2*b3^4 + 
             b2^2*b3^4 - 2*b1*b2*b3^4 + b1^2*r2^4 + 
             b2^2*r2^4 - 2*b1*b2*r2^4 + b1^2*r3^4 + 
             b2^2*r3^4 - 2*b1*b2*r3^4 - 2*b1^3*b2^3 + 
             2*a3^2*b1*b2^3 - 2*b1^3*b3^3 - 2*b2^3*b3^3 + 
             2*b1*b2^2*b3^3 + 2*a2^2*b1*b3^3 - 
             2*a2^2*b2*b3^3 + 2*b1^2*b2*b3^3 - 
             4*b1^2*r2*r3^3 - 4*b2^2*r2*r3^3 + 
             8*b1*b2*r2*r3^3 + a2^4*b1^2 + a3^4*b1^2 - 
             2*a2^2*a3^2*b1^2 + a3^4*b2^2 + b1^4*b2^2 + 
             2*a2^2*b1^2*b2^2 - 4*a3^2*b1^2*b2^2 + 
             a2^4*b3^2 + b1^4*b3^2 + b2^4*b3^2 + 
             2*b1*b2^3*b3^2 - 4*a2^2*b1^2*b3^2 + 
             2*a3^2*b1^2*b3^2 + 2*a2^2*b2^2*b3^2 + 
             2*a3^2*b2^2*b3^2 - 6*b1^2*b2^2*b3^2 + 
             2*b1^3*b2*b3^2 + 2*a2^2*b1*b2*b3^2 - 
             4*a3^2*b1*b2*b3^2 - a2^4*r2^2 - b1^4*r2^2 - 
             b2^4*r2^2 + 2*b1*b2^3*r2^2 - 2*a3^2*b1^2*
              r2^2 - 2*a2^2*b2^2*r2^2 - 2*a3^2*b2^2*r2^2 - 
             2*b1^2*b2^2*r2^2 - 2*b1^2*b3^2*r2^2 - 
             2*b2^2*b3^2*r2^2 + 4*b1*b2*b3^2*r2^2 + 
             2*b1^3*b2*r2^2 + 2*a2^2*b1*b2*r2^2 + 
             4*a3^2*b1*b2*r2^2 + 2*b1^3*b3*r2^2 + 
             2*b2^3*b3*r2^2 - 2*b1*b2^2*b3*r2^2 - 
             2*a2^2*b1*b3*r2^2 + 2*a2^2*b2*b3*r2^2 - 
             2*b1^2*b2*b3*r2^2 - a2^4*r3^2 - b1^4*r3^2 - 
             b2^4*r3^2 + 2*b1*b2^3*r3^2 - 2*a3^2*b1^2*
              r3^2 - 2*a2^2*b2^2*r3^2 - 2*a3^2*b2^2*r3^2 - 
             2*b1^2*b2^2*r3^2 - 2*b1^2*b3^2*r3^2 - 
             2*b2^2*b3^2*r3^2 + 4*b1*b2*b3^2*r3^2 + 
             6*b1^2*r2^2*r3^2 + 6*b2^2*r2^2*r3^2 - 
             12*b1*b2*r2^2*r3^2 + 2*b1^3*b2*r3^2 + 
             2*a2^2*b1*b2*r3^2 + 4*a3^2*b1*b2*r3^2 + 
             2*b1^3*b3*r3^2 + 2*b2^3*b3*r3^2 - 
             2*b1*b2^2*b3*r3^2 - 2*a2^2*b1*b3*r3^2 + 
             2*a2^2*b2*b3*r3^2 - 2*b1^2*b2*b3*r3^2 - 
             2*a2^2*b1^3*b2 + 2*a3^2*b1^3*b2 - 
             2*a3^4*b1*b2 + 2*a2^2*a3^2*b1*b2 - 
             2*b1*b2^4*b3 + 2*a2^2*b1^3*b3 - 2*a3^2*b1^3*
              b3 - 2*a3^2*b2^3*b3 + 2*b1^2*b2^3*b3 + 
             2*b1^3*b2^2*b3 - 4*a2^2*b1*b2^2*b3 + 
             2*a3^2*b1*b2^2*b3 - 2*a2^4*b1*b3 + 
             2*a2^2*a3^2*b1*b3 - 2*b1^4*b2*b3 - 
             2*a2^2*a3^2*b2*b3 + 2*a2^2*b1^2*b2*b3 + 
             2*a3^2*b1^2*b2*b3 - 4*b1^2*r2^3*r3 - 
             4*b2^2*r2^3*r3 + 8*b1*b2*r2^3*r3 + 
             2*a2^4*r2*r3 + 2*b1^4*r2*r3 + 2*b2^4*r2*r3 - 
             4*b1*b2^3*r2*r3 + 4*a3^2*b1^2*r2*r3 + 
             4*a2^2*b2^2*r2*r3 + 4*a3^2*b2^2*r2*r3 + 
             4*b1^2*b2^2*r2*r3 + 4*b1^2*b3^2*r2*r3 + 
             4*b2^2*b3^2*r2*r3 - 8*b1*b2*b3^2*r2*r3 - 
             4*b1^3*b2*r2*r3 - 4*a2^2*b1*b2*r2*r3 - 
             8*a3^2*b1*b2*r2*r3 - 4*b1^3*b3*r2*r3 - 
             4*b2^3*b3*r2*r3 + 4*b1*b2^2*b3*r2*r3 + 
             4*a2^2*b1*b3*r2*r3 - 4*a2^2*b2*b3*r2*r3 + 
             4*b1^2*b2*b3*r2*r3)]))/(4*b2^2*a1^2 + 
        4*b3^2*a1^2 - 4*r2^2*a1^2 - 4*r3^2*a1^2 - 
        8*b2*b3*a1^2 + 8*r2*r3*a1^2 - 8*a3*b2^2*a1 - 
        8*a2*b3^2*a1 + 8*a2*r2^2*a1 + 8*a2*r3^2*a1 - 
        8*a2*b1*b2*a1 + 8*a3*b1*b2*a1 + 8*a2*b1*b3*a1 - 
        8*a3*b1*b3*a1 + 8*a2*b2*b3*a1 + 8*a3*b2*b3*a1 - 
        16*a2*r2*r3*a1 + 4*a2^2*b1^2 + 4*a3^2*b1^2 - 
        8*a2*a3*b1^2 + 4*a3^2*b2^2 + 4*a2^2*b3^2 - 
        4*a2^2*r2^2 - 4*b1^2*r2^2 - 4*b2^2*r2^2 + 
        8*b1*b2*r2^2 - 4*a2^2*r3^2 - 4*b1^2*r3^2 - 
        4*b2^2*r3^2 + 8*b1*b2*r3^2 - 8*a3^2*b1*b2 + 
        8*a2*a3*b1*b2 - 8*a2^2*b1*b3 + 8*a2*a3*b1*b3 - 
        8*a2*a3*b2*b3 + 8*a2^2*r2*r3 + 8*b1^2*r2*r3 + 
        8*b2^2*r2*r3 - 16*b1*b2*r2*r3))/
     (-2*b1*r2 + 2*b2*r2 + 2*b1*r3 - 2*b2*r3)}}\
\>", "Output",
 CellChangeTimes->{
  3.561203760301923*^9, {3.561203803495838*^9, 3.561203826448155*^9}, {
   3.5612038852686977`*^9, 3.561203892305954*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "r", "*", 
           RowBox[{"(", 
            RowBox[{"b3", "-", "b1"}], ")"}], "*", "f"}], "+", "g"}], ")"}], 
        "/", 
        RowBox[{"(", 
         RowBox[{"2", "*", "d", "*", 
          RowBox[{"(", 
           RowBox[{"b3", "-", "b1"}], ")"}]}], ")"}]}], ")"}], "^", "2"}], 
     "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "r", "*", 
           RowBox[{"(", 
            RowBox[{"a3", "-", "a1"}], ")"}], "*", "e"}], "+", "c"}], ")"}], 
        "/", 
        RowBox[{"(", 
         RowBox[{"2", "*", "d", "*", 
          RowBox[{"(", 
           RowBox[{"a3", "-", "a1"}], ")"}]}], ")"}]}], ")"}], "^", "2"}]}], 
    "\[Equal]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"r", "+", "r3"}], ")"}], "^", "2"}]}], ",", 
   RowBox[{"{", "r", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5612041431938553`*^9, 3.561204316703691*^9}, {
  3.561204354311557*^9, 3.5612044062607307`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"r", " ", "->", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], "*", "a1", "*", 
         RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"4", "*", "a3", "*", 
         RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "c", "*", "e"}], 
        " ", "-", " ", 
        RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "c", "*", "e"}], 
        " ", "-", " ", "\n", "      ", 
        RowBox[{"4", "*", "a1", "*", 
         RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"4", "*", "a3", "*", 
         RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
        RowBox[{"4", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", "+", 
        " ", 
        RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "f", "*", "g"}], 
        " ", "-", " ", "\n", "      ", 
        RowBox[{"4", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", "+", 
        " ", 
        RowBox[{"4", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", "-", 
        " ", 
        RowBox[{"8", "*", "a1", "*", "a3", "*", "b3", "*", "f", "*", "g"}], 
        " ", "+", " ", 
        RowBox[{"4", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", "-", 
        " ", "\n", "      ", 
        RowBox[{"8", "*", 
         RowBox[{"a1", "^", "2"}], "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", "a1", "*", "a3", "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"8", "*", 
         RowBox[{"a3", "^", "2"}], "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", "      ", 
        
        RowBox[{"16", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"32", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", "      ", 
        
        RowBox[{"8", "*", 
         RowBox[{"a1", "^", "2"}], "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", "a1", "*", "a3", "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"8", "*", 
         RowBox[{"a3", "^", "2"}], "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", "      ", 
        
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", "*", "a1", "*", 
              RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{"4", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{
             "8", "*", "a1", "*", "b1", "*", "b3", "*", "c", "*", "e"}], " ", 
             "+", " ", "\n", "          ", 
             RowBox[{
             "8", "*", "a3", "*", "b1", "*", "b3", "*", "c", "*", "e"}], " ", 
             "+", " ", 
             RowBox[{"4", "*", "a1", "*", 
              RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{"4", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", 
             "-", " ", "\n", "          ", 
             RowBox[{
             "8", "*", "a1", "*", "a3", "*", "b1", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", 
             "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{
             "8", "*", "a1", "*", "a3", "*", "b3", "*", "f", "*", "g"}], " ", 
             "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
             "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
             RowBox[{"16", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"32", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "\n", "           ", "r3"}], " ", 
             "-", " ", 
             RowBox[{"16", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
             "          ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}]}], ")"}], "^", "2"}], " ", 
          "-", " ", "\n", "        ", 
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}]}], ")"}], "*", "\n", "         ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"-", 
                RowBox[{"b1", "^", "2"}]}], ")"}], "*", 
              RowBox[{"c", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"2", "*", "b1", "*", "b3", "*", 
              RowBox[{"c", "^", "2"}]}], " ", "-", " ", 
             RowBox[{
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"c", "^", "2"}]}], " ", "-", " ", 
             RowBox[{
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"g", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"2", "*", "a1", "*", "a3", "*", 
              RowBox[{"g", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"g", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}]}], ")"}]}], ")"}]}]}], "}"}], ",", " ", 
   "\n", "  ", 
   RowBox[{"{", 
    RowBox[{"r", " ", "->", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], "*", "a1", "*", 
         RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"4", "*", "a3", "*", 
         RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "c", "*", "e"}], 
        " ", "-", " ", 
        RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "c", "*", "e"}], 
        " ", "-", " ", "\n", "      ", 
        RowBox[{"4", "*", "a1", "*", 
         RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
        RowBox[{"4", "*", "a3", "*", 
         RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
        RowBox[{"4", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", "+", 
        " ", 
        RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "f", "*", "g"}], 
        " ", "-", " ", "\n", "      ", 
        RowBox[{"4", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", "+", 
        " ", 
        RowBox[{"4", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", "-", 
        " ", 
        RowBox[{"8", "*", "a1", "*", "a3", "*", "b3", "*", "f", "*", "g"}], 
        " ", "+", " ", 
        RowBox[{"4", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", "-", 
        " ", "\n", "      ", 
        RowBox[{"8", "*", 
         RowBox[{"a1", "^", "2"}], "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", "a1", "*", "a3", "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"8", "*", 
         RowBox[{"a3", "^", "2"}], "*", 
         RowBox[{"b1", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", "      ", 
        
        RowBox[{"16", "*", 
         RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"32", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", 
         RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", "      ", 
        
        RowBox[{"8", "*", 
         RowBox[{"a1", "^", "2"}], "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
        RowBox[{"16", "*", "a1", "*", "a3", "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
        RowBox[{"8", "*", 
         RowBox[{"a3", "^", "2"}], "*", 
         RowBox[{"b3", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", "      ", 
        
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", "*", "a1", "*", 
              RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{"4", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{
             "8", "*", "a1", "*", "b1", "*", "b3", "*", "c", "*", "e"}], " ", 
             "+", " ", "\n", "          ", 
             RowBox[{
             "8", "*", "a3", "*", "b1", "*", "b3", "*", "c", "*", "e"}], " ", 
             "+", " ", 
             RowBox[{"4", "*", "a1", "*", 
              RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "-", " ", 
             RowBox[{"4", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", "c", "*", "e"}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", 
             "-", " ", "\n", "          ", 
             RowBox[{
             "8", "*", "a1", "*", "a3", "*", "b1", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "f", "*", "g"}], " ", 
             "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{
             "8", "*", "a1", "*", "a3", "*", "b3", "*", "f", "*", "g"}], " ", 
             "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b3", "*", "f", "*", "g"}], " ", 
             "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
             "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", 
             RowBox[{"16", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"32", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "\n", "           ", "r3"}], " ", 
             "-", " ", 
             RowBox[{"16", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
             "          ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", "r3"}]}], ")"}], "^", "2"}], " ", 
          "-", " ", "\n", "        ", 
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"f", "^", "2"}]}]}], ")"}], "*", "\n", "         ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"-", 
                RowBox[{"b1", "^", "2"}]}], ")"}], "*", 
              RowBox[{"c", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"2", "*", "b1", "*", "b3", "*", 
              RowBox[{"c", "^", "2"}]}], " ", "-", " ", 
             RowBox[{
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"c", "^", "2"}]}], " ", "-", " ", 
             RowBox[{
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"g", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"2", "*", "a1", "*", "a3", "*", 
              RowBox[{"g", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
             RowBox[{
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"g", "^", "2"}]}], " ", "+", " ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b1", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", 
              RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
             RowBox[{"8", "*", "a1", "*", "a3", "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
             RowBox[{"4", "*", 
              RowBox[{"a3", "^", "2"}], "*", 
              RowBox[{"b3", "^", "2"}], "*", 
              RowBox[{"d", "^", "2"}], "*", 
              RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"d", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"e", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b1", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", 
           RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"16", "*", "a1", "*", "a3", "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
          RowBox[{"8", "*", 
           RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", 
          RowBox[{"4", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "+", " ", 
          RowBox[{"8", "*", "a1", "*", "a3", "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
          RowBox[{"4", "*", 
           RowBox[{"a3", "^", "2"}], "*", 
           RowBox[{"b3", "^", "2"}], "*", 
           RowBox[{"f", "^", "2"}]}]}], ")"}]}], ")"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.56120441640174*^9, 3.561204457809623*^9},
 FormatType->"InputForm"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r1", "+", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r3", "+", "r"}], ")"}], "^", "2"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "r"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561206090791566*^9, 3.5612060909610023`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{
         "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{
         "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{
         "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
       "\n", "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
           "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r2"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"r", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "b2", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}]}], "}"}], ",", " ", 
   "\n", "  ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{
         "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{
         "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{
         "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "-", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
       "\n", "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
           "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r2"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"r", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "b2", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.561206099373176*^9, 3.56120652843795*^9},
 FormatType->"InputForm"]
}, Open  ]]
},
WindowSize->{740, 867},
WindowMargins->{{Automatic, 454}, {Automatic, 11}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (October 10, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 92, 1, 30, "Input"],
Cell[CellGroupData[{
Cell[674, 25, 1166, 39, 50, "Input"],
Cell[1843, 66, 528, 11, 27, "Message"],
Cell[2374, 79, 528, 11, 27, "Message"],
Cell[2905, 92, 528, 11, 27, "Message"],
Cell[3436, 105, 527, 11, 24, "Message"],
Cell[3966, 118, 518, 16, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4521, 139, 1164, 39, 50, "Input"],
Cell[5688, 180, 528, 11, 27, "Message"],
Cell[6219, 193, 526, 11, 27, "Message"],
Cell[6748, 206, 528, 11, 27, "Message"],
Cell[7279, 219, 527, 11, 24, "Message"],
Cell[7809, 232, 517, 15, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8363, 252, 1337, 42, 69, "Input"],
Cell[9703, 296, 750, 14, 62, "Message"],
Cell[10456, 312, 765, 14, 80, "Message"],
Cell[11224, 328, 749, 15, 81, "Message"],
Cell[11976, 345, 276, 7, 24, "Message"]
}, Open  ]],
Cell[12267, 355, 551, 18, 50, "Input"],
Cell[CellGroupData[{
Cell[12843, 377, 428, 14, 30, "Input"],
Cell[13274, 393, 458, 10, 24, "Message"],
Cell[13735, 405, 148, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13920, 414, 561, 17, 69, "Input"],
Cell[14484, 433, 1413, 55, 108, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15934, 493, 1210, 40, 69, "Input"],
Cell[17147, 535, 182686, 3452, 55182, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[199870, 3992, 1177, 38, 69, "Input"],
Cell[201050, 4032, 37100, 774, 1199, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[238187, 4811, 1212, 40, 69, "Input"],
Cell[239402, 4853, 3562580, 67664, 107695, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

