(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[   3564759,      67749]
NotebookOptionsPosition[   3564441,      67733]
NotebookOutlinePosition[   3564778,      67748]
CellTagsIndexPosition[   3564735,      67745]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a1"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b1"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r1", "-", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a2"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b2"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r2", "+", "r"}], ")"}], "^", "2"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "a3"}], ")"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"y", "-", "b3"}], ")"}], "^", "2"}]}], "==", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r3", "+", "r"}], ")"}], "^", "2"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "r"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.561301193564465*^9, 3.561301196848743*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{
         "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{
         "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{
         "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
       "\n", "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
           "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"r", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}]}], "}"}], ",", " ", 
   "\n", "  ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", 
          RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{
         "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
         "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}],
          " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a3", "^", "3"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b3", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", 
          RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{
         "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", 
          RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "+", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}],
          " ", "+", " ", "\n", "      ", 
         RowBox[{
         "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
         "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
         "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"8", "*", "a2", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", "r1", "*", 
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", 
          RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"a2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", 
          RowBox[{"a2", "^", "3"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"b2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a2", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r1", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"8", "*", "a1", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a2", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a3", "*", 
          RowBox[{"r2", "^", "2"}], "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"4", "*", "a1", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r1", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"4", "*", "a1", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
         RowBox[{"4", "*", "a2", "*", "r2", "*", 
          RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", "\n", "          ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-", " ",
            "\n", "        ", 
           RowBox[{"4", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
              "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "a1", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "+", " ", "\n", "          ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
              "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a1", "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r2"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"8", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b3", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"8", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2", "*",
                "r3"}], " ", "-", " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "          ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "          ", 
              RowBox[{"4", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", "\n", 
              "          ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"a2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"b2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"6", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "4"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"2", "*", 
               RowBox[{"r2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", "\n", "          ", 
              
              RowBox[{"2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "+", " ", 
              RowBox[{
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{"2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
              RowBox[{
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}], "/", 
       "\n", "     ", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
           "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
           "+", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b3", "^", "2"}], "*", 
            RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", 
           RowBox[{"8", "*", 
            RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "+", " ", "\n", "       ", 
           RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
           "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "a1", "*", "a2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"a2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "       ", 
           RowBox[{"4", "*", 
            RowBox[{"b1", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
           RowBox[{"8", "*", "b1", "*", "b2", "*", 
            RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
           RowBox[{"4", "*", 
            RowBox[{"b2", "^", "2"}], "*", 
            RowBox[{"r3", "^", "2"}]}]}], ")"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"y", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r1"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "r2"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b3", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r2"}], " ", "+", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "r3"}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"r1", "^", "2"}], "*", "r3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
         RowBox[{"r1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"r2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "r2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "r3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}], ",", " ", "\n", 
     "   ", 
     RowBox[{"r", " ", "->", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{"a2", "^", "2"}]}], ")"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b1"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"a3", "^", "2"}], "*", "b2"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b2"}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"a1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"a2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"b1", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{
          RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{"b3", "*", 
          RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b3", "*", 
          RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
         RowBox[{"b1", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
         RowBox[{"b2", "*", 
          RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b1", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a3", "*", "b2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "+", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a1", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}], " ", "-", " ", "\n", 
         "      ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a2", "*", "b3", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b2"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", "b3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", "b3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", 
               RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
              " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a3", "^", "3"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b3", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"8", "*", 
               RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "+", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", 
              RowBox[{
              "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{
              "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "+", " ", "\n", "         ", 
              RowBox[{
              "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
              " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "+", 
              " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", 
              " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
              RowBox[{"8", "*", "a2", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", "r1", "*", 
               RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", "\n", 
              "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"a2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", 
               RowBox[{"a2", "^", "3"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"b2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"8", "*", "a2", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r1", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"8", "*", "a1", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a2", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a3", "*", 
               RowBox[{"r2", "^", "2"}], "*", 
               RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", "         ", 
              RowBox[{"4", "*", "a2", "*", "r1", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
              RowBox[{"4", "*", "a1", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
              RowBox[{"4", "*", "a2", "*", "r2", "*", 
               RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", "         ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b1", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "b2", "*", 
                    "b3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "16", "*", "a2", "*", "b1", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b2", "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "3"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "a3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a3", "*", "b1", "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{
                   "8", "*", "a1", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "a2", "*", "b1", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{
                   "16", "*", "a1", "*", "b2", "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a1", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "a2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "a1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "a2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}]}], ")"}], "^", "2"}], " ", "-",
                 " ", 
                RowBox[{"4", "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], 
                   " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "+", " ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], 
                   " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "a1", "*", "a2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}]}], ")"}], "*", "\n", 
                 "            ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "b1", "*", "b2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "b1", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "b2", "*", "b3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "b3"}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"b3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r2"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r2"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"8", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", "r1", "*", "r2"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "4"}], "*", "r1", "*", "r2"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b2", "*", 
                    RowBox[{"b3", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "4"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r1",
                     "*", "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "4"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r1",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"8", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", "r1", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "+", " ", "\n", "             ", 
                   RowBox[{"8", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "+", " ", 
                   RowBox[{"8", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", "r2",
                     "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", "r2", "*", 
                    "r3"}], " ", "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", "\n", "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"8", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", "r3"}], " ", 
                   "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "4"}], "*", "r2", "*", "r3"}], " ", 
                   "-", " ", "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"4", "*", "b2", "*", "b3", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "+", " ", 
                   RowBox[{"4", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   "\n", "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "3"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "4"}], "*", "r3"}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"a1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"a2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"b2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "b2", "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "3"}], "*", "b3", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{
                   "8", "*", "b1", "*", "b2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                   "4", "*", "b1", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{
                   "4", "*", "b2", "*", "b3", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"4", "*", 
                    RowBox[{"a1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b2", "*", "b3", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b3", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"6", "*", 
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"r2", "^", "4"}], "*", 
                    RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r1", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"a2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"4", "*", "b1", "*", "b2", "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"b2", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r1", "^", "2"}], "*", "r2", "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{"2", "*", "r1", "*", 
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{"2", "*", 
                    RowBox[{"r2", "^", "3"}], "*", 
                    RowBox[{"r3", "^", "3"}]}], " ", "+", " ", 
                   RowBox[{
                    RowBox[{"b1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "b1", "*", "b2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "+", " ", "\n", 
                   "             ", 
                   RowBox[{
                    RowBox[{"b2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r1", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{"2", "*", "r1", "*", "r2", "*", 
                    RowBox[{"r3", "^", "4"}]}], " ", "-", " ", 
                   RowBox[{
                    RowBox[{"r2", "^", "2"}], "*", 
                    RowBox[{"r3", "^", "4"}]}]}], ")"}]}]}], "]"}]}], ")"}]}],
            ")"}], "/", "\n", "       ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "b1", "*", "b2"}], " ", "+", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"b2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "b1", "*", "b3"}], " ", "-", " ", 
            "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b1", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "b2", "*", "b3"}], " ", "+", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "b2", "*", "b3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "b2", "*", "b3"}], " ", 
            "+", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"b3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r1", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r2"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r2"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b3", "^", "2"}], "*", "r1", "*", "r2"}], " ", "-", " ", 
            
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b3", "^", "2"}], "*", 
             RowBox[{"r2", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r1", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b2", "^", "2"}], "*", "r1", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r1", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"a1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "a1", "*", "a2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "a1", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "a2", "*", "a3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", 
            RowBox[{"8", "*", 
             RowBox[{"b1", "^", "2"}], "*", "r2", "*", "r3"}], " ", "-", " ", 
            
            RowBox[{"8", "*", "b1", "*", "b2", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"8", "*", "b1", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "+", " ", "\n", "        ", 
            RowBox[{"8", "*", "b2", "*", "b3", "*", "r2", "*", "r3"}], " ", 
            "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "a1", "*", "a2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"a2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", "\n", "        ", 
            RowBox[{"4", "*", 
             RowBox[{"b1", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "+", " ", 
            RowBox[{"8", "*", "b1", "*", "b2", "*", 
             RowBox[{"r3", "^", "2"}]}], " ", "-", " ", 
            RowBox[{"4", "*", 
             RowBox[{"b2", "^", "2"}], "*", 
             RowBox[{"r3", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", "\n", 
       "     ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b2", "*", "r1"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r1"}], " ", "-", " ", 
         RowBox[{"2", "*", "b1", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b3", "*", "r2"}], " ", "+", " ", 
         RowBox[{"2", "*", "b1", "*", "r3"}], " ", "-", " ", 
         RowBox[{"2", "*", "b2", "*", "r3"}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.561301233363455*^9, 3.561301339562405*^9},
 FormatType->"InputForm"]
}, Open  ]]
},
WindowSize->{740, 867},
WindowMargins->{{149, Automatic}, {Automatic, 28}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (October 10, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 1210, 40, 69, "Input"],
Cell[1792, 64, 3562633, 67666, 107695, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

